/*
Copyright 2017 Ziadin Givan

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

https://github.com/givanz/Vvvebjs
*/

bgcolorClasses = ["bg-primary", "bg-secondary", "bg-success", "bg-danger", "bg-warning", "bg-info", "bg-light", "bg-dark", "bg-white"]

bgcolorSelectOptions = 
[{
	value: "Default",
	text: ""
}, 
{
	value: "bg-primary",
	text: "Primary"
}, {
	value: "bg-secondary",
	text: "Secondary"
}, {
	value: "bg-success",
	text: "Success"
}, {
	value: "bg-danger",
	text: "Danger"
}, {
	value: "bg-warning",
	text: "Warning"
}, {
	value: "bg-info",
	text: "Info"
}, {
	value: "bg-light",
	text: "Light"
}, {
	value: "bg-dark",
	text: "Dark"
}, {
	value: "bg-white",
	text: "White"
}];

function changeNodeName(node, newNodeName)
{
	var newNode;
	newNode = document.createElement(newNodeName);
	attributes = node.get(0).attributes;
	
	for (i = 0, len = attributes.length; i < len; i++) {
		newNode.setAttribute(attributes[i].nodeName, attributes[i].nodeValue);
	}

	$(newNode).append($(node).contents());
	$(node).replaceWith(newNode);
	
	return newNode;
}



var shorttag_val = document.getElementById("id_shortag").value;
var strArray = shorttag_val.split(",");
// Display array values on page
var new_tags = '';
for(var i = 0; i < strArray.length; i++){
    var joinComa = '';
    if(i!=0) {
        joinComa = ',';
    }
   new_tags+=joinComa+' "html/'+strArray[i]+'"';
}

/* Removed facilities

    "html/gridrow", "html/button", "html/buttongroup", "html/buttontoolbar", "html/heading", "html/jumbotron", "html/alert", "html/card", "html/listgroup", "html/hr", "html/taglabel", "html/badge", "html/progress", "html/navbar", "html/breadcrumbs", "html/pagination", "html/form", "html/textinput", "html/textareainput", "html/selectinput", "html/fileinput", "html/checkbox", "html/radiobutton", "html/table", "html/link",
*/

var componetsnArray = ["html/container",  "html/image",  "html/paragraph", "html/fileinput", "html/textinput","html/gridrow"];


var shorttag_val = document.getElementById("id_shortag").value;
   var strArray = shorttag_val.split(",");
   // Display array values on page 
   for(var i = 0; i < strArray.length; i++){
       componetsnArray.push(strArray[i]);//this will only which form shortag that we need to
   }

Vvveb.ComponentsGroup['Bootstrap 4'] = componetsnArray;



var base_sort = 100;//start sorting for base component from 100 to allow extended properties to be first
var style_section = 'style';

Vvveb.Components.add("_base", {
    name: "Element",
	properties: [{
        key: "element_header",
        inputtype: SectionInput,
        name:false,
        sort:base_sort++,
        data: {header:"General"},
    }, {
        name: "Id",
        key: "id",
        htmlAttr: "id",
        sort: base_sort++,
        inline:true,
        col:6,
        inputtype: TextInput
    }, {
        name: "Class",
        key: "class",
        htmlAttr: "class",
        sort: base_sort++,
        inline:true,
        col:6,
        inputtype: TextInput
    }
   ]
});    

//display
Vvveb.Components.extend("_base", "_base", {
	 properties: [
     {
        key: "display_header",
        inputtype: SectionInput,
        name:false,
        sort: base_sort++,
		section: style_section,
        data: {header:"Display"},
    }, {
        name: "Display",
        key: "display",
        htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: SelectInput,
        validValues: ["block", "inline", "inline-block", "none"],
        data: {
            options: [{
                value: "block",
                text: "Block"
            }, {
                value: "inline",
                text: "Inline"
            }, {
                value: "inline-block",
                text: "Inline Block"
            }, {
                value: "none",
                text: "none"
            }]
        }
    }, {
        name: "Position",
        key: "position",
        htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: SelectInput,
        validValues: ["static", "fixed", "relative", "absolute"],
        data: {
            options: [{
                value: "static",
                text: "Static"
            }, {
                value: "fixed",
                text: "Fixed"
            }, {
                value: "relative",
                text: "Relative"
            }, {
                value: "absolute",
                text: "Absolute"
            }]
        }
    }, {
        name: "Top",
        key: "top",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        parent:"",
        inputtype: CssUnitInput
	}, {
        name: "Left",
        key: "left",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        parent:"",
        inputtype: CssUnitInput
    }, {
        name: "Bottom",
        key: "bottom",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        parent:"",
        inputtype: CssUnitInput
	}, {
        name: "Right",
        key: "right",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        parent:"",
        inputtype: CssUnitInput
    },{
        name: "Float",
        key: "float",
        htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:12,
        inline:true,
        inputtype: RadioButtonInput,
        data: {
			extraclass:"btn-group-sm btn-group-fullwidth",
            options: [{
                value: "none",
                icon:"la la-close",
                //text: "None",
                title: "None",
                checked:true,
            }, {
                value: "left",
                //text: "Left",
                title: "Left",
                icon:"la la-align-left",
                checked:false,
            }, {
                value: "right",
                //text: "Right",
                title: "Right",
                icon:"la la-align-right",
                checked:false,
            }],
         }
	}, {
        name: "Opacity",
        key: "opacity",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:12,
		inline:true,
        parent:"",
        inputtype: RangeInput,
        data:{
			max: 1, //max zoom level
			min:0,
			step:0.1
       },
	}, {
        name: "Background Color",
        key: "background-color",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
		htmlAttr: "style",
        inputtype: ColorInput,
	}, {
        name: "Text Color",
        key: "color",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
		htmlAttr: "style",
        inputtype: ColorInput,
  	}]
});    

//Typography
Vvveb.Components.extend("_base", "_base", {
	 properties: [
     {
		key: "typography_header",
		inputtype: SectionInput,
		name:false,
		sort: base_sort++,
		section: style_section,
		data: {header:"Typography"},
    }, {
        name: "Font family",
        key: "font-family",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: SelectInput,
        data: {
			options: [{
				value: "",
				text: "Default"
			}, {
				value: "Arial, Helvetica, sans-serif",
				text: "Arial"
			}, {
				value: 'Lucida Sans Unicode", "Lucida Grande", sans-serif',
				text: 'Lucida Grande'
			}, {
				value: 'Palatino Linotype", "Book Antiqua", Palatino, serif',
				text: 'Palatino Linotype'
			}, {
				value: '"Times New Roman", Times, serif',
				text: 'Times New Roman'
			}, {
				value: "Georgia, serif",
				text: "Georgia, serif"
			}, {
				value: "Tahoma, Geneva, sans-serif",
				text: "Tahoma"
			}, {
				value: 'Comic Sans MS, cursive, sans-serif',
				text: 'Comic Sans'
			}, {
				value: 'Verdana, Geneva, sans-serif',
				text: 'Verdana'
			}, {
				value: 'Impact, Charcoal, sans-serif',
				text: 'Impact'
			}, {
				value: 'Arial Black, Gadget, sans-serif',
				text: 'Arial Black'
			}, {
				value: 'Trebuchet MS, Helvetica, sans-serif',
				text: 'Trebuchet'
			}, {
				value: 'Courier New", Courier, monospace',
				text: 'Courier New", Courier, monospace'
			}, {
				value: 'Brush Script MT, sans-serif',
				text: 'Brush Script'
			}]
		}
	}, {
        name: "Font weight",
        key: "font-weight",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: SelectInput,
        data: {
			options: [{
				value: "",
				text: "Default"
			}, {	
				value: "100",
				text: "Thin"
			}, {
				value: "200",
				text: "Extra-Light"
			}, {
				value: "300",
				text: "Light"
			}, {
				value: "400",
				text: "Normal"
			}, {
				value: "500",
				text: "Medium"
			}, {
				value: "600",
				text: "Semi-Bold"
			}, {
				value: "700",
				text: "Bold"
			}, {
				value: "800",
				text: "Extra-Bold"
			}, {
				value: "900",
				text: "Ultra-Bold"
			}],
		}
	}, {
        name: "Text align",
        key: "text-align",
        htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:12,
        inline:true,
        inputtype: RadioButtonInput,
        data: {
			extraclass:"btn-group-sm btn-group-fullwidth",
            options: [{
                value: "none",
                icon:"la la-close",
                //text: "None",
                title: "None",
                checked:true,
            }, {
                value: "left",
                //text: "Left",
                title: "Left",
                icon:"la la-align-left",
                checked:false,
            }, {
                value: "center",
                //text: "Center",
                title: "Center",
                icon:"la la-align-center",
                checked:false,
            }, {
                value: "right",
                //text: "Right",
                title: "Right",
                icon:"la la-align-right",
                checked:false,
            }, {
                value: "justify",
                //text: "justify",
                title: "Justify",
                icon:"la la-align-justify",
                checked:false,
            }],
        },
	}, {
        name: "Line height",
        key: "line-height",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Letter spacing",
        key: "letter-spacing",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Text decoration",
        key: "text-decoration-line",
        htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:12,
        inline:true,
        inputtype: RadioButtonInput,
        data: {
			extraclass:"btn-group-sm btn-group-fullwidth",
            options: [{
                value: "none",
                icon:"la la-close",
                //text: "None",
                title: "None",
                checked:true,
            }, {
                value: "underline",
                //text: "Left",
                title: "underline",
                icon:"la la-long-arrow-down",
                checked:false,
            }, {
                value: "overline",
                //text: "Right",
                title: "overline",
                icon:"la la-long-arrow-up",
                checked:false,
            }, {
                value: "line-through",
                //text: "Right",
                title: "Line Through",
                icon:"la la-strikethrough",
                checked:false,
            }, {
                value: "underline overline",
                //text: "justify",
                title: "Underline Overline",
                icon:"la la-arrows-v",
                checked:false,
            }],
        },
	}, {
        name: "Decoration Color",
        key: "text-decoration-color",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
		htmlAttr: "style",
        inputtype: ColorInput,
	}, {
        name: "Decoration style",
        key: "text-decoration-style",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: SelectInput,
        data: {
			options: [{
				value: "",
				text: "Default"
			}, {	
				value: "solid",
				text: "Solid"
			}, {
				value: "wavy",
				text: "Wavy"
			}, {
				value: "dotted",
				text: "Dotted"
			}, {
				value: "dashed",
				text: "Dashed"
			}, {
				value: "double",
				text: "Double"
			}],
		}
  }]
})
    
//Size
Vvveb.Components.extend("_base", "_base", {
	 properties: [{
		key: "size_header",
		inputtype: SectionInput,
		name:false,
		sort: base_sort++,
		section: style_section,
		data: {header:"Size", expanded:false},
	}, {
        name: "Width",
        key: "width",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Height",
        key: "height",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Min Width",
        key: "min-width",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Min Height",
        key: "min-height",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Max Width",
        key: "max-width",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Max Height",
        key: "max-height",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
    }]
});

//Margin
Vvveb.Components.extend("_base", "_base", {
	 properties: [{
		key: "margins_header",
		inputtype: SectionInput,
		name:false,
		sort: base_sort++,
		section: style_section,
		data: {header:"Margin", expanded:false},
	}, {
        name: "Top",
        key: "margin-top",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Right",
        key: "margin-right",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
    }, {
        name: "Bottom",
        key: "margin-bottom",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
    }, {
        name: "Left",
        key: "margin-left",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
    }]
});

//Padding
Vvveb.Components.extend("_base", "_base", {
	 properties: [{
		key: "paddings_header",
		inputtype: SectionInput,
		name:false,
		sort: base_sort++,
		section: style_section,
		data: {header:"Padding", expanded:false},
	}, {
        name: "Top",
        key: "padding-top",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
	}, {
        name: "Right",
        key: "padding-right",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
    }, {
        name: "Bottom",
        key: "padding-bottom",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
    }, {
        name: "Left",
        key: "padding-left",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
    }]
});


//Border
Vvveb.Components.extend("_base", "_base", {
	 properties: [{
		key: "border_header",
		inputtype: SectionInput,
		name:false,
		sort: base_sort++,
		section: style_section,
		data: {header:"Border", expanded:false},
	 }, {        
        name: "Style",
        key: "border-style",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:12,
		inline:true,
        inputtype: SelectInput,
        data: {
			options: [{
				value: "",
				text: "Default"
			}, {	
				value: "solid",
				text: "Solid"
			}, {
				value: "dotted",
				text: "Dotted"
			}, {
				value: "dashed",
				text: "Dashed"
			}],
		}
	}, {
        name: "Width",
        key: "border-width",
		htmlAttr: "style",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
        inputtype: CssUnitInput
   	}, {
        name: "Color",
        key: "border-color",
        sort: base_sort++,
		section: style_section,
        col:6,
		inline:true,
		htmlAttr: "style",
        inputtype: ColorInput,
    }]
});    

//Background image
Vvveb.Components.extend("_base", "_base", {
	 properties: [{
		key: "background_image_header",
		inputtype: SectionInput,
		name:false,
		sort: base_sort++,
		section: style_section,
		data: {header:"Background Image", expanded:false},
	 },{
        name: "Image",
        key: "Image",
        sort: base_sort++,
		section: style_section,
		//htmlAttr: "style",
        inputtype: ImageInput,
        
        init: function(node) {
			var image = $(node).css("background-image").replace(/^url\(['"]?(.+)['"]?\)/, '$1');
			return image;
        },

		onChange: function(node, value) {
			
			$(node).css('background-image', 'url(' + value + ')');
			
			return node;
		}        

   	}, {
        name: "Repeat",
        key: "background-repeat",
        sort: base_sort++,
		section: style_section,
		htmlAttr: "style",
        inputtype: SelectInput,
        data: {
			options: [{
				value: "",
				text: "Default"
			}, {	
				value: "repeat-x",
				text: "repeat-x"
			}, {
				value: "repeat-y",
				text: "repeat-y"
			}, {
				value: "no-repeat",
				text: "no-repeat"
			}],
		}
   	}, {
        name: "Size",
        key: "background-size",
        sort: base_sort++,
		section: style_section,
		htmlAttr: "style",
        inputtype: SelectInput,
        data: {
			options: [{
				value: "",
				text: "Default"
			}, {	
				value: "contain",
				text: "contain"
			}, {
				value: "cover",
				text: "cover"
			}],
		}
   	}, {
        name: "Position x",
        key: "background-position-x",
        sort: base_sort++,
		section: style_section,
		htmlAttr: "style",
        col:6,
		inline:true,
		inputtype: SelectInput,
        data: {
			options: [{
				value: "",
				text: "Default"
			}, {	
				value: "center",
				text: "center"
			}, {	
				value: "right",
				text: "right"
			}, {
				value: "left",
				text: "left"
			}],
		}
   	}, {
        name: "Position y",
        key: "background-position-y",
        sort: base_sort++,
		section: style_section,
		htmlAttr: "style",
        col:6,
		inline:true,
		inputtype: SelectInput,
        data: {
			options: [{
				value: "",
				text: "Default"
			}, {	
				value: "center",
				text: "center"
			}, {	
				value: "top",
				text: "top"
			}, {
				value: "bottom",
				text: "bottom"
			}],
		}
    }]
});    

Vvveb.Components.extend("_base", "html/container", {
    classes: ["container", "container-fluid"],
    image: "icons/container.svg",
    html: '<div class="container" style="min-height:150px;"><div class="m-5">Container</div></div>',
    name: "Container",
    properties: [
     {
        name: "Type",
        key: "type",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["container", "container-fluid"],
        data: {
            options: [{
                value: "container",
                text: "Default"
            }, {
                value: "container-fluid",
                text: "Fluid"
            }]
        }
    },
	{
        name: "Background",
        key: "background",
		htmlAttr: "class",
        validValues: bgcolorClasses,
        inputtype: SelectInput,
        data: {
            options: bgcolorSelectOptions
        }
    },
	{
        name: "Background Color",
        key: "background-color",
		htmlAttr: "style",
        inputtype: ColorInput,
    },
	{
        name: "Text Color",
        key: "color",
		htmlAttr: "style",
        inputtype: ColorInput,
    }],
});

Vvveb.Components.extend("_base", "html/heading", {
    image: "icons/heading.svg",
    name: "Heading",
    nodes: ["h1", "h2","h3", "h4","h5","h6"],
    html: "<h1>Heading</h1>",
    
	properties: [
	{
        name: "Size",
        key: "size",
        inputtype: SelectInput,
        
        onChange: function(node, value) {
			
			return changeNodeName(node, "h" + value);
		},	
			
        init: function(node) {
            var regex;
            regex = /H(\d)/.exec(node.nodeName);
            if (regex && regex[1]) {
                return regex[1]
            }
            return 1
        },
        
        data:{
			options: [{
                value: "1",
                text: "1"
            }, {
                value: "2",
                text: "2"
            }, {
                value: "3",
                text: "3"
            }, {
                value: "4",
                text: "4"
            }, {
                value: "5",
                text: "5"
            }, {
                value: "6",
                text: "6"
            }]
       },
    }]
});    
Vvveb.Components.extend("_base", "html/link", {
    nodes: ["a"],
    name: "Link",
    html: '<a href="#" class="d-inline-block"><span>Link</span></a>',
	image: "icons/link.svg",
    properties: [{
        name: "Url",
        key: "href",
        htmlAttr: "href",
        inputtype: LinkInput
    }, {
        name: "Target",
        key: "target",
        htmlAttr: "target",
        inputtype: TextInput
    }]
});
Vvveb.Components.extend("_base", "html/image", {
    nodes: ["img"],
    name: "Image",
    html: '<img src="' +  Vvveb.baseUrl + 'icons/image.svg" height="128" width="128">',
    /*
    afterDrop: function (node)
	{
		node.attr("src", '');
		return node;
	},*/
    image: "icons/image.svg",
    properties: [{
        name: "Image",
        key: "src",
        htmlAttr: "src",
        inputtype: ImageInput
    }, {
        name: "Width",
        key: "width",
        htmlAttr: "width",
        inputtype: TextInput
    }, {
        name: "Height",
        key: "height",
        htmlAttr: "height",
        inputtype: TextInput
    }, {
        name: "Alt",
        key: "alt",
        htmlAttr: "alt",
        inputtype: TextInput
    }]
});
Vvveb.Components.add("html/hr", {
    image: "icons/hr.svg",
    nodes: ["hr"],
    name: "Horizontal Rule",
    html: "<hr>"
});
Vvveb.Components.extend("_base", "html/label", {
    name: "Label",
    nodes: ["label"],
    html: '<label for="">Label</label>',
    properties: [{
        name: "For id",
        htmlAttr: "for",
        key: "for",
        inputtype: TextInput
    }]
});
Vvveb.Components.extend("_base", "html/button", {
    classes: ["btn", "btn-link"],
    name: "Button",
    image: "icons/button.svg",
    html: '<button type="button" class="btn btn-primary">Primary</button>',
    properties: [{
        name: "Link To",
        key: "href",
        htmlAttr: "href",
        inputtype: LinkInput
    }, {
        name: "Type",
        key: "type",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["btn-default", "btn-primary", "btn-info", "btn-success", "btn-warning", "btn-info", "btn-light", "btn-dark", "btn-outline-primary", "btn-outline-info", "btn-outline-success", "btn-outline-warning", "btn-outline-info", "btn-outline-light", "btn-outline-dark", "btn-link"],
        data: {
            options: [{
                value: "btn-default",
                text: "Default"
            }, {
                value: "btn-primary",
                text: "Primary"
            }, {
                value: "btn btn-info",
                text: "Info"
            }, {
                value: "btn-success",
                text: "Success"
            }, {
                value: "btn-warning",
                text: "Warning"
            }, {
                value: "btn-info",
                text: "Info"
            }, {
                value: "btn-light",
                text: "Light"
            }, {
                value: "btn-dark",
                text: "Dark"
            }, {
                value: "btn-outline-primary",
                text: "Primary outline"
            }, {
                value: "btn btn-outline-info",
                text: "Info outline"
            }, {
                value: "btn-outline-success",
                text: "Success outline"
            }, {
                value: "btn-outline-warning",
                text: "Warning outline"
            }, {
                value: "btn-outline-info",
                text: "Info outline"
            }, {
                value: "btn-outline-light",
                text: "Light outline"
            }, {
                value: "btn-outline-dark",
                text: "Dark outline"
            }, {
                value: "btn-link",
                text: "Link"
            }]
        }
    }, {
        name: "Size",
        key: "size",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["btn-lg", "btn-sm"],
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "btn-lg",
                text: "Large"
            }, {
                value: "btn-sm",
                text: "Small"
            }]
        }
    }, {
        name: "Target",
        key: "target",
        htmlAttr: "target",
        inputtype: TextInput
    }, {
        name: "Disabled",
        key: "disabled",
        htmlAttr: "class",
        inputtype: ToggleInput,
        validValues: ["disabled"],
        data: {
            on: "disabled",
            off: ""
        }
    }]
});
Vvveb.Components.extend("_base", "html/buttongroup", {
    classes: ["btn-group"],
    name: "Button Group",
    image: "icons/button_group.svg",
    html: '<div class="btn-group" role="group" aria-label="Basic example"><button type="button" class="btn btn-secondary">Left</button><button type="button" class="btn btn-secondary">Middle</button> <button type="button" class="btn btn-secondary">Right</button></div>',
	properties: [{
	    name: "Size",
        key: "size",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["btn-group-lg", "btn-group-sm"],
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "btn-group-lg",
                text: "Large"
            }, {
                value: "btn-group-sm",
                text: "Small"
            }]
        }
    }, {
	    name: "Alignment",
        key: "alignment",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["btn-group", "btn-group-vertical"],
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "btn-group",
                text: "Horizontal"
            }, {
                value: "btn-group-vertical",
                text: "Vertical"
            }]
        }
    }]
});
Vvveb.Components.extend("_base", "html/buttontoolbar", {
    classes: ["btn-toolbar"],
    name: "Button Toolbar",
    image: "icons/button_toolbar.svg",
    html: '<div class="btn-toolbar" role="toolbar" aria-label="Toolbar with button groups">\
		  <div class="btn-group mr-2" role="group" aria-label="First group">\
			<button type="button" class="btn btn-secondary">1</button>\
			<button type="button" class="btn btn-secondary">2</button>\
			<button type="button" class="btn btn-secondary">3</button>\
			<button type="button" class="btn btn-secondary">4</button>\
		  </div>\
		  <div class="btn-group mr-2" role="group" aria-label="Second group">\
			<button type="button" class="btn btn-secondary">5</button>\
			<button type="button" class="btn btn-secondary">6</button>\
			<button type="button" class="btn btn-secondary">7</button>\
		  </div>\
		  <div class="btn-group" role="group" aria-label="Third group">\
			<button type="button" class="btn btn-secondary">8</button>\
		  </div>\
		</div>'
});
Vvveb.Components.extend("_base","html/alert", {
    classes: ["alert"],
    name: "Alert",
    image: "icons/alert.svg",
    html: '<div class="alert alert-warning alert-dismissible fade show" role="alert">\
		  <button type="button" class="close" data-dismiss="alert" aria-label="Close">\
			<span aria-hidden="true">&times;</span>\
		  </button>\
		  <strong>Holy guacamole!</strong> You should check in on some of those fields below.\
		</div>',
    properties: [{
        name: "Type",
        key: "type",
        htmlAttr: "class",
        validValues: ["alert-primary", "alert-secondary", "alert-success", "alert-danger", "alert-warning", "alert-info", "alert-light", "alert-dark"],
        inputtype: SelectInput,
        data: {
            options: [{
                value: "alert-primary",
                text: "Default"
            }, {
                value: "alert-secondary",
                text: "Secondary"
            }, {
                value: "alert-success",
                text: "Success"
            }, {
                value: "alert-danger",
                text: "Danger"
            }, {
                value: "alert-warning",
                text: "Warning"
            }, {
                value: "alert-info",
                text: "Info"
            }, {
                value: "alert-light",
                text: "Light"
            }, {
                value: "alert-dark",
                text: "Dark"
            }]
        }
    }]
});
Vvveb.Components.extend("_base", "html/badge", {
    classes: ["badge"],
    image: "icons/badge.svg",
    name: "Badge",
    html: '<span class="badge badge-primary">Primary badge</span>',
    properties: [{
        name: "Color",
        key: "color",
        htmlAttr: "class",
        validValues:["badge-primary", "badge-secondary", "badge-success", "badge-danger", "badge-warning", "badge-info", "badge-light", "badge-dark"],
        inputtype: SelectInput,
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "badge-primary",
                text: "Primary"
            }, {
                value: "badge-secondary",
                text: "Secondary"
            }, {
                value: "badge-success",
                text: "Success"
            }, {
                value: "badge-warning",
                text: "Warning"
            }, {
                value: "badge-danger",
                text: "Danger"
            }, {
                value: "badge-info",
                text: "Info"
            }, {
                value: "badge-light",
                text: "Light"
            }, {
                value: "badge-dark",
                text: "Dark"
            }]
        }
     }]
});
Vvveb.Components.extend("_base", "html/card", {
    classes: ["card"],
    image: "icons/panel.svg",
    name: "Card",
    html: '<div class="card">\
		  <img class="card-img-top" src="../libs/builder/icons/image.svg" alt="Card image cap" width="128" height="128">\
		  <div class="card-body">\
			<h4 class="card-title">Card title</h4>\
			<p class="card-text">Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>\
			<a href="#" class="btn btn-primary">Go somewhere</a>\
		  </div>\
		</div>'
});
Vvveb.Components.extend("_base", "html/listgroup", {
    name: "List Group",
    image: "icons/list_group.svg",
    classes: ["list-group"],
    html: '<ul class="list-group">\n  <li class="list-group-item">\n    <span class="badge">14</span>\n    Cras justo odio\n  </li>\n  <li class="list-group-item">\n    <span class="badge">2</span>\n    Dapibus ac facilisis in\n  </li>\n  <li class="list-group-item">\n    <span class="badge">1</span>\n    Morbi leo risus\n  </li>\n</ul>'
});
Vvveb.Components.extend("_base", "html/listitem", {
    name: "List Item",
    classes: ["list-group-item"],
    html: '<li class="list-group-item"><span class="badge">14</span> Cras justo odio</li>'
});
Vvveb.Components.extend("_base", "html/breadcrumbs", {
    classes: ["breadcrumb"],
    name: "Breadcrumbs",
    image: "icons/breadcrumbs.svg",
    html: '<ol class="breadcrumb">\
		  <li class="breadcrumb-item active"><a href="#">Home</a></li>\
		  <li class="breadcrumb-item active"><a href="#">Library</a></li>\
		  <li class="breadcrumb-item active">Data 3</li>\
		</ol>'
});
Vvveb.Components.extend("_base", "html/breadcrumbitem", {
	classes: ["breadcrumb-item"],
    name: "Breadcrumb Item",
    html: '<li class="breadcrumb-item"><a href="#">Library</a></li>',
    properties: [{
        name: "Active",
        key: "active",
        htmlAttr: "class",
        validValues: ["", "active"],
        inputtype: ToggleInput,
        data: {
            on: "active",
            off: ""
        }
    }]
});
Vvveb.Components.extend("_base", "html/pagination", {
    classes: ["pagination"],
    name: "Pagination",
    image: "icons/pagination.svg",
    html: '<nav aria-label="Page navigation example">\
	  <ul class="pagination">\
		<li class="page-item"><a class="page-link" href="#">Previous</a></li>\
		<li class="page-item"><a class="page-link" href="#">1</a></li>\
		<li class="page-item"><a class="page-link" href="#">2</a></li>\
		<li class="page-item"><a class="page-link" href="#">3</a></li>\
		<li class="page-item"><a class="page-link" href="#">Next</a></li>\
	  </ul>\
	</nav>',

    properties: [{
        name: "Size",
        key: "size",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["btn-lg", "btn-sm"],
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "btn-lg",
                text: "Large"
            }, {
                value: "btn-sm",
                text: "Small"
            }]
        }
    },{
        name: "Alignment",
        key: "alignment",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["justify-content-center", "justify-content-end"],
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "justify-content-center",
                text: "Center"
            }, {
                value: "justify-content-end",
                text: "Right"
            }]
        }
    }]	
});
Vvveb.Components.extend("_base", "html/pageitem", {
	classes: ["page-item"],
    html: '<li class="page-item"><a class="page-link" href="#">1</a></li>',
    name: "Pagination Item",
    properties: [{
        name: "Link To",
        key: "href",
        htmlAttr: "href",
        child:".page-link",
        inputtype: TextInput
    }, {
        name: "Disabled",
        key: "disabled",
        htmlAttr: "class",
        validValues: ["disabled"],
        inputtype: ToggleInput,
        data: {
            on: "disabled",
            off: ""
        }
   }]
});





Vvveb.Components.extend("_base", "html/progress", {
    classes: ["progress"],
    name: "Progress Bar",
    image: "icons/progressbar.svg",
    html: '<div class="progress"><div class="progress-bar w-25"></div></div>',
    properties: [{
        name: "Background",
        key: "background",
		htmlAttr: "class",
        validValues: bgcolorClasses,
        inputtype: SelectInput,
        data: {
            options: bgcolorSelectOptions
        }
    },
    {
        name: "Progress",
        key: "background",
        child:".progress-bar",
		htmlAttr: "class",
        validValues: ["", "w-25", "w-50", "w-75", "w-100"],
        inputtype: SelectInput,
        data: {
            options: [{
                value: "",
                text: "None"
            }, {
                value: "w-25",
                text: "25%"
            }, {
                value: "w-50",
                text: "50%"
            }, {
                value: "w-75",
                text: "75%"
            }, {
                value: "w-100",
                text: "100%"
            }]
        }
    }, 
    {
        name: "Progress background",
        key: "background",
        child:".progress-bar",
		htmlAttr: "class",
        validValues: bgcolorClasses,
        inputtype: SelectInput,
        data: {
            options: bgcolorSelectOptions
        }
    }, {
        name: "Striped",
        key: "striped",
        child:".progress-bar",
        htmlAttr: "class",
        validValues: ["", "progress-bar-striped"],
        inputtype: ToggleInput,
        data: {
            on: "progress-bar-striped",
            off: "",
        }
    }, {
        name: "Animated",
        key: "animated",
        child:".progress-bar",
        htmlAttr: "class",
        validValues: ["", "progress-bar-animated"],
        inputtype: ToggleInput,
        data: {
            on: "progress-bar-animated",
            off: "",
        }
    }]
});
Vvveb.Components.extend("_base", "html/jumbotron", {
    classes: ["jumbotron"],
    image: "icons/jumbotron.svg",
    name: "Jumbotron",
    html: '<div class="jumbotron">\
		  <h1 class="display-3">Hello, world!</h1>\
		  <p class="lead">This is a simple hero unit, a simple jumbotron-style component for calling extra attention to featured content or information.</p>\
		  <hr class="my-4">\
		  <p>It uses utility classes for typography and spacing to space content out within the larger container.</p>\
		  <p class="lead">\
			<a class="btn btn-primary btn-lg" href="#" role="button">Learn more</a>\
		  </p>\
		</div>'
});
Vvveb.Components.extend("_base", "html/navbar", {
    classes: ["navbar"],
    image: "icons/navbar.svg",
    name: "Nav Bar",
    html: '<nav class="navbar navbar-expand-lg navbar-light bg-light">\
		  <a class="navbar-brand" href="#">Navbar</a>\
		  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">\
			<span class="navbar-toggler-icon"></span>\
		  </button>\
		\
		  <div class="collapse navbar-collapse" id="navbarSupportedContent">\
			<ul class="navbar-nav mr-auto">\
			  <li class="nav-item active">\
				<a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>\
			  </li>\
			  <li class="nav-item">\
				<a class="nav-link" href="#">Link</a>\
			  </li>\
			  <li class="nav-item">\
				<a class="nav-link disabled" href="#">Disabled</a>\
			  </li>\
			</ul>\
			<form class="form-inline my-2 my-lg-0">\
			  <input class="form-control mr-sm-2" type="text" placeholder="Search" aria-label="Search">\
			  <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>\
			</form>\
		  </div>\
		</nav>',
    
    properties: [{
        name: "Color theme",
        key: "color",
        htmlAttr: "class",
        validValues: ["navbar-light", "navbar-dark"],
        inputtype: SelectInput,
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "navbar-light",
                text: "Light"
            }, {
                value: "navbar-dark",
                text: "Dark"
            }]
        }
    },{
        name: "Background color",
        key: "background",
        htmlAttr: "class",
        validValues: bgcolorClasses,
        inputtype: SelectInput,
        data: {
            options: bgcolorSelectOptions
        }
    }, {
        name: "Placement",
        key: "placement",
        htmlAttr: "class",
        validValues: ["fixed-top", "fixed-bottom", "sticky-top"],
        inputtype: SelectInput,
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "fixed-top",
                text: "Fixed Top"
            }, {
                value: "fixed-bottom",
                text: "Fixed Bottom"
            }, {
                value: "sticky-top",
                text: "Sticky top"
            }]
        }
    }]
});

Vvveb.Components.extend("_base", "html/form", {
    nodes: ["form"],
    image: "icons/form.svg",
    name: "Form",
    html: '<form><div class="form-group"><label>Text</label><input type="text" class="form-control"></div></div></form>',
    properties: [{
        name: "Style",
        key: "style",
        htmlAttr: "class",
        validValues: ["", "form-search", "form-inline", "form-horizontal"],
        inputtype: SelectInput,
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "form-search",
                text: "Search"
            }, {
                value: "form-inline",
                text: "Inline"
            }, {
                value: "form-horizontal",
                text: "Horizontal"
            }]
        }
    }, {
        name: "Action",
        key: "action",
        htmlAttr: "action",
        inputtype: TextInput
    }, {
        name: "Method",
        key: "method",
        htmlAttr: "method",
        inputtype: TextInput
    }]
});


Vvveb.Components.extend("_base", "html/textinput", {

    

    name: "Text Input",
	attributes: {"type":"text"},
    image: "icons/text_input.svg",
    html: '<div class="form-group"><label>Text</label><input type="text" class="form-control c-comoman-txt" name="n-custom-name[]" ></div></div>',
    properties: [{
        name: "Value",
        key: "value",
        htmlAttr: "value",
        inputtype: TextInput
    }, {
        name: "Placeholder",
        key: "placeholder",
        htmlAttr: "placeholder",
        inputtype: TextInput
    }]
});

Vvveb.Components.extend("_base", "html/selectinput", {
	nodes: ["select"],
    name: "Select Input",
    image: "icons/select_input.svg",
    html: '<div class="form-group"><label>Choose an option </label><select class="form-control"><option value="value1">Text 1</option><option value="value2">Text 2</option><option value="value3">Text 3</option></select></div>',

	beforeInit: function (node)
	{
		properties = [];
		var i = 0;
		
		$(node).find('option').each(function() {

			data = {"value": this.value, "text": this.text};
			
			i++;
			properties.push({
				name: "Option " + i,
				key: "option" + i,
				//index: i - 1,
				optionNode: this,
				inputtype: TextValueInput,
				data: data,
				onChange: function(node, value, input) {
					
					option = $(this.optionNode);
					
					//if remove button is clicked remove option and render row properties
					if (input.nodeName == 'BUTTON')
					{
						option.remove();
						Vvveb.Components.render("html/selectinput");
						return node;
					}

					if (input.name == "value") option.attr("value", value); 
					else if (input.name == "text") option.text(value);
					
					return node;
				},	
			});
		});
		
		//remove all option properties
		this.properties = this.properties.filter(function(item) {
			return item.key.indexOf("option") === -1;
		});
		
		//add remaining properties to generated column properties
		properties.push(this.properties[0]);
		
		this.properties = properties;
		return node;
	},
    
    properties: [{
        name: "Option",
        key: "option1",
        inputtype: TextValueInput
	}, {
        name: "Option",
        key: "option2",
        inputtype: TextValueInput
	}, {
        name: "",
        key: "addChild",
        inputtype: ButtonInput,
        data: {text:"Add option", icon:"la-plus"},
        onChange: function(node)
        {
			 $(node).append('<option value="value">Text</option>');
			 
			 //render component properties again to include the new column inputs
			 Vvveb.Components.render("html/selectinput");
			 
			 return node;
		}
	}]
});
Vvveb.Components.extend("_base", "html/textareainput", {
    name: "Text Area",
    image: "icons/text_area.svg",
    html: '<div class="form-group"><label>Your response:</label><textarea class="form-control"></textarea></div>'
});
Vvveb.Components.extend("_base", "html/radiobutton", {
    name: "Radio Button",
	attributes: {"type":"radio"},
    image: "icons/radio.svg",
    html: '<label class="radio"><input type="radio"> Radio</label>',
    properties: [{
        name: "Name",
        key: "name",
        htmlAttr: "name",
        inputtype: TextInput
    }]
});
Vvveb.Components.extend("_base", "html/checkbox", {
    name: "Checkbox",
    attributes: {"type":"checkbox"},
    image: "icons/checkbox.svg",
    html: '<label class="checkbox"><input type="checkbox"> Checkbox</label>',
    properties: [{
        name: "Name",
        key: "name",
        htmlAttr: "name",
        inputtype: TextInput
    }]
});
Vvveb.Components.extend("_base", "html/fileinput", {
    name: "Input group",
	attributes: {"type":"file"},
    image: "icons/text_input.svg",
    html: '<div class="form-group">\
			  <input type="file" name="n-custom-file-name[]" class="form-control c-comoman-file">\
			</div>'
});
Vvveb.Components.extend("_base", "html/table", {
    nodes: ["table"],
    classes: ["table"],
    image: "icons/table.svg",
    name: "Table",
    html: '<table class="table">\
		  <thead>\
			<tr>\
			  <th>#</th>\
			  <th>First Name</th>\
			  <th>Last Name</th>\
			  <th>Username</th>\
			</tr>\
		  </thead>\
		  <tbody>\
			<tr>\
			  <th scope="row">1</th>\
			  <td>Mark</td>\
			  <td>Otto</td>\
			  <td>@mdo</td>\
			</tr>\
			<tr>\
			  <th scope="row">2</th>\
			  <td>Jacob</td>\
			  <td>Thornton</td>\
			  <td>@fat</td>\
			</tr>\
			<tr>\
			  <th scope="row">3</th>\
			  <td>Larry</td>\
			  <td>the Bird</td>\
			  <td>@twitter</td>\
			</tr>\
		  </tbody>\
		</table>',
    properties: [
	{
        name: "Type",
        key: "type",
		htmlAttr: "class",
        validValues: ["table-primary", "table-secondary", "table-success", "table-danger", "table-warning", "table-info", "table-light", "table-dark", "table-white"],
        inputtype: SelectInput,
        data: {
            options: [{
				value: "Default",
				text: ""
			}, {
				value: "table-primary",
				text: "Primary"
			}, {
				value: "table-secondary",
				text: "Secondary"
			}, {
				value: "table-success",
				text: "Success"
			}, {
				value: "table-danger",
				text: "Danger"
			}, {
				value: "table-warning",
				text: "Warning"
			}, {
				value: "table-info",
				text: "Info"
			}, {
				value: "table-light",
				text: "Light"
			}, {
				value: "table-dark",
				text: "Dark"
			}, {
				value: "table-white",
				text: "White"
			}]
        }
    },
	{
        name: "Responsive",
        key: "responsive",
        htmlAttr: "class",
        validValues: ["table-responsive"],
        inputtype: ToggleInput,
        data: {
            on: "table-responsive",
            off: ""
        }
    },   
	{
        name: "Small",
        key: "small",
        htmlAttr: "class",
        validValues: ["table-sm"],
        inputtype: ToggleInput,
        data: {
            on: "table-sm",
            off: ""
        }
    },   
	{
        name: "Hover",
        key: "hover",
        htmlAttr: "class",
        validValues: ["table-hover"],
        inputtype: ToggleInput,
        data: {
            on: "table-hover",
            off: ""
        }
    },   
	{
        name: "Bordered",
        key: "bordered",
        htmlAttr: "class",
        validValues: ["table-bordered"],
        inputtype: ToggleInput,
        data: {
            on: "table-bordered",
            off: ""
        }
    },   
	{
        name: "Striped",
        key: "striped",
        htmlAttr: "class",
        validValues: ["table-striped"],
        inputtype: ToggleInput,
        data: {
            on: "table-striped",
            off: ""
        }
    },   
	{
        name: "Inverse",
        key: "inverse",
        htmlAttr: "class",
        validValues: ["table-inverse"],
        inputtype: ToggleInput,
        data: {
            on: "table-inverse",
            off: ""
        }
    },   
    {
        name: "Head options",
        key: "head",
        htmlAttr: "class",
        child:"thead",
        inputtype: SelectInput,
        validValues: ["", "thead-inverse", "thead-default"],
        data: {
            options: [{
                value: "",
                text: "None"
            }, {
                value: "thead-default",
                text: "Default"
            }, {
                value: "thead-inverse",
                text: "Inverse"
            }]
        }
    }]
});
Vvveb.Components.extend("_base", "html/tablerow", {
    nodes: ["tr"],
    name: "Table Row",
    html: "<tr><td>Cell 1</td><td>Cell 2</td><td>Cell 3</td></tr>",
    properties: [{
        name: "Type",
        key: "type",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["", "success", "danger", "warning", "active"],
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "success",
                text: "Success"
            }, {
                value: "error",
                text: "Error"
            }, {
                value: "warning",
                text: "Warning"
            }, {
                value: "active",
                text: "Active"
            }]
        }
    }]
});
Vvveb.Components.extend("_base", "html/tablecell", {
    nodes: ["td"],
    name: "Table Cell",
    html: "<td>Cell</td>"
});
Vvveb.Components.extend("_base", "html/tableheadercell", {
    nodes: ["th"],
    name: "Table Header Cell",
    html: "<th>Head</th>"
});
Vvveb.Components.extend("_base", "html/tablehead", {
    nodes: ["thead"],
    name: "Table Head",
    html: "<thead><tr><th>Head 1</th><th>Head 2</th><th>Head 3</th></tr></thead>",
    properties: [{
        name: "Type",
        key: "type",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["", "success", "danger", "warning", "info"],
        data: {
            options: [{
                value: "",
                text: "Default"
            }, {
                value: "success",
                text: "Success"
            }, {
                value: "anger",
                text: "Error"
            }, {
                value: "warning",
                text: "Warning"
            }, {
                value: "info",
                text: "Info"
            }]
        }
    }]
});
Vvveb.Components.extend("_base", "html/tablebody", {
    nodes: ["tbody"],
    name: "Table Body",
    html: "<tbody><tr><td>Cell 1</td><td>Cell 2</td><td>Cell 3</td></tr></tbody>"
});

Vvveb.Components.add("_base", {
    name: "Element",
    properties: [{
        name: "Id",
        key: "id",
        htmlAttr: "id",
        inputtype: TextInput
    }, {
        name: "Class",
        key: "class",
        htmlAttr: "class",
        inputtype: TextInput
    }]
});

Vvveb.Components.add("html/gridcolumn", {
    name: "Grid Column",
    image: "icons/grid_row.svg",
    classesRegex: ["col-"],
    html: '<div class="col-sm-4"><h3>col-sm-4</h3></div>',
    properties: [{
        name: "Column",
        key: "column",
        inputtype: GridInput,
        data: {hide_remove:true},
		
		beforeInit: function(node) {
			_class = $(node).attr("class");
			
			var reg = /col-([^-\$ ]*)?-?(\d+)/g; 
			var match;

			while ((match = reg.exec(_class)) != null) {
				this.data["col" + ((match[1] != undefined)?"_" + match[1]:"")] = match[2];
			}
		},
		
		onChange: function(node, value, input) {
			var _class = node.attr("class");
			
			//remove previous breakpoint column size
			_class = _class.replace(new RegExp(input.name + '-\\d+?'), '');
			//add new column size
			if (value) _class +=  ' ' + input.name + '-' + value;
			node.attr("class", _class);
			
			return node;
		},				
	}]
});
Vvveb.Components.add("html/gridrow", {
    name: "Grid Row",
    image: "icons/grid_row.svg",
    classes: ["row"],
    html: '<div class="row"><div class="col-sm-4"><h3>col-sm-4</h3></div><div class="col-sm-4 col-5"><h3>col-sm-4</h3></div><div class="col-sm-4"><h3>col-sm-4</h3></div></div>',
    
	beforeInit: function (node)
	{
		properties = [];
		var i = 0;
		var j = 0;
		
		$(node).find('[class*="col-"]').each(function() {
			_class = $(this).attr("class");
			
			var reg = /col-([^-\$ ]*)?-?(\d+)/g; 
			var match;
			var data = {};

			while ((match = reg.exec(_class)) != null) {
				data["col" + ((match[1] != undefined)?"_" + match[1]:"")] = match[2];
			}
			
			i++;
			properties.push({
				name: "Column " + i,
				key: "column" + i,
				//index: i - 1,
				columnNode: this,
				col:12,
				inline:true,
				inputtype: GridInput,
				data: data,
				onChange: function(node, value, input) {

					//column = $('[class*="col-"]:eq(' + this.index + ')', node);
					var column = $(this.columnNode);
					
					//if remove button is clicked remove column and render row properties
					if (input.nodeName == 'BUTTON')
					{
						column.remove();
						Vvveb.Components.render("html/gridrow");
						return node;
					}

					//if select input then change column class
					_class = column.attr("class");
					
					//remove previous breakpoint column size
					_class = _class.replace(new RegExp(input.name + '-\\d+?'), '');
					//add new column size
					if (value) _class +=  ' ' + input.name + '-' + value;
					column.attr("class", _class);
					
					//console.log(this, node, value, input, input.name);
					
					return node;
				},	
			});
		});
		
		//remove all column properties
		this.properties = this.properties.filter(function(item) {
			return item.key.indexOf("column") === -1;
		});
		
		//add remaining properties to generated column properties
		properties.push(this.properties[0]);
		
		this.properties = properties;
		return node;
	},
    
    properties: [{
        name: "Column",
        key: "column1",
        inputtype: GridInput
	}, {
        name: "Column",
        key: "column1",
        inline:true,
        col:12,
        inputtype: GridInput
	}, {
        name: "",
        key: "addChild",
        inputtype: ButtonInput,
        data: {text:"Add column", icon:"la la-plus"},
        onChange: function(node)
        {
			 $(node).append('<div class="col-3">Col-3</div>');
			 
			 //render component properties again to include the new column inputs
			 Vvveb.Components.render("html/gridrow");
			 
			 return node;
		}
	}]
});


Vvveb.Components.extend("_base", "html/paragraph", {
    nodes: ["p"],
    name: "Paragraph",
	image: "icons/paragraph.svg",
	html: '<p>Lorem ipsum</p>',
    properties: [{
        name: "Text align",
        key: "text-align",
        htmlAttr: "class",
        inputtype: SelectInput,
        validValues: ["", "text-left", "text-center", "text-right"],
        inputtype: RadioButtonInput,
        data: {
			extraclass:"btn-group-sm btn-group-fullwidth",
            options: [{
                value: "",
                icon:"la la-close",
                //text: "None",
                title: "None",
                checked:true,
            }, {
                value: "left",
                //text: "Left",
                title: "text-left",
                icon:"la la-align-left",
                checked:false,
            }, {
                value: "text-center",
                //text: "Center",
                title: "Center",
                icon:"la la-align-center",
                checked:false,
            }, {
                value: "text-right",
                //text: "Right",
                title: "Right",
                icon:"la la-align-right",
                checked:false,
            }],
        },
	}]
});

for(var i = 0; i < strArray.length; i++){
    var joinComa = '';
    if(i!=0) {
        joinComa = ',';
    }
    new_tags+=joinComa+' "html/'+strArray[i]+'"';

    Vvveb.Components.extend("_base", "html/"+strArray[i], {
        name: strArray[i],
        image: "icons/formicon.png",
        html: '<p>'+strArray[i]+'</p>',
        
    });

}

Vvveb.Components.extend("_base", "html/form-id-1", {
    name: "form-id-1",
    image: "icons/formicon.png",
    html: '<p>[form-id-1]</p>',
    
});

Vvveb.Components.extend("_base", "html/form-id-2", {
    name: "form-id-2",
    image: "icons/formicon.png",
    html: '<p>[form-id-2]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-3", {
    name: "form-id-3",
    image: "icons/formicon.png",
    html: '<p>[form-id-3]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-4", {
    name: "form-id-4",
    image: "icons/formicon.png",
    html: '<p>[form-id-4]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-5", {
    name: "form-id-5",
    image: "icons/formicon.png",
    html: '<p>[form-id-5]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-6", {
    name: "form-id-6",
    image: "icons/formicon.png",
    html: '<p>[form-id-6]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-7", {
    name: "form-id-7",
    image: "icons/formicon.png",
    html: '<p>[form-id-7]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-8", {
    name: "form-id-8",
    image: "icons/formicon.png",
    html: '<p>[form-id-8]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-9", {
    name: "form-id-9",
    image: "icons/formicon.png",
    html: '<p>[form-id-1]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-10", {
    name: "form-id-10",
    image: "icons/formicon.png",
    html: '<p>[form-id-10]</p>',
    
});

Vvveb.Components.extend("_base", "html/form-id-10", {
    name: "form-id-10",
    image: "icons/formicon.png",
    html: '<p>[form-id-10]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-11", {
    name: "form-id-11",
    image: "icons/formicon.png",
    html: '<p>[form-id-11]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-12", {
    name: "form-id-12",
    image: "icons/formicon.png",
    html: '<p>[form-id-12]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-13", {
    name: "form-id-13",
    image: "icons/formicon.png",
    html: '<p>[form-id-13]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-14", {
    name: "form-id-14",
    image: "icons/formicon.png",
    html: '<p>[form-id-14]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-15", {
    name: "form-id-15",
    image: "icons/formicon.png",
    html: '<p>[form-id-15]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-16", {
    name: "form-id-16",
    image: "icons/formicon.png",
    html: '<p>[form-id-16]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-17", {
    name: "form-id-17",
    image: "icons/formicon.png",
    html: '<p>[form-id-17]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-18", {
    name: "form-id-18",
    image: "icons/formicon.png",
    html: '<p>[form-id-18]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-19", {
    name: "form-id-19",
    image: "icons/formicon.png",
    html: '<p>[form-id-19]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-20", {
    name: "form-id-20",
    image: "icons/formicon.png",
    html: '<p>[form-id-20]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-21", {
    name: "form-id-21",
    image: "icons/formicon.png",
    html: '<p>[form-id-21]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-22", {
    name: "form-id-22",
    image: "icons/formicon.png",
    html: '<p>[form-id-22]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-23", {
    name: "form-id-23",
    image: "icons/formicon.png",
    html: '<p>[form-id-23]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-24", {
    name: "form-id-24",
    image: "icons/formicon.png",
    html: '<p>[form-id-24]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-25", {
    name: "form-id-25",
    image: "icons/formicon.png",
    html: '<p>[form-id-25]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-26", {
    name: "form-id-26",
    image: "icons/formicon.png",
    html: '<p>[form-id-26]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-27", {
    name: "form-id-27",
    image: "icons/formicon.png",
    html: '<p>[form-id-27]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-28", {
    name: "form-id-28",
    image: "icons/formicon.png",
    html: '<p>[form-id-28]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-29", {
    name: "form-id-29",
    image: "icons/formicon.png",
    html: '<p>[form-id-29]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-30", {
    name: "form-id-30",
    image: "icons/formicon.png",
    html: '<p>[form-id-30]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-31", {
    name: "form-id-31",
    image: "icons/formicon.png",
    html: '<p>[form-id-31]</p>',
    
});
Vvveb.Components.extend("_base", "html/form-id-32", {
    name: "form-id-32",
    image: "icons/formicon.png",
    html: '<p>[form-id-32]</p>',
    
});

Vvveb.Components.extend("_base", "html/form-id-33", {
     name: "form-id-33",
     image: "icons/formicon.png",
     html: "<p>[form-id-33]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-34", {
     name: "form-id-34",
     image: "icons/formicon.png",
     html: "<p>[form-id-34]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-35", {
     name: "form-id-35",
     image: "icons/formicon.png",
     html: "<p>[form-id-35]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-36", {
     name: "form-id-36",
     image: "icons/formicon.png",
     html: "<p>[form-id-36]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-37", {
     name: "form-id-37",
     image: "icons/formicon.png",
     html: "<p>[form-id-37]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-38", {
     name: "form-id-38",
     image: "icons/formicon.png",
     html: "<p>[form-id-38]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-39", {
     name: "form-id-39",
     image: "icons/formicon.png",
     html: "<p>[form-id-39]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-40", {
     name: "form-id-40",
     image: "icons/formicon.png",
     html: "<p>[form-id-40]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-41", {
     name: "form-id-41",
     image: "icons/formicon.png",
     html: "<p>[form-id-41]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-42", {
     name: "form-id-42",
     image: "icons/formicon.png",
     html: "<p>[form-id-42]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-43", {
     name: "form-id-43",
     image: "icons/formicon.png",
     html: "<p>[form-id-43]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-44", {
     name: "form-id-44",
     image: "icons/formicon.png",
     html: "<p>[form-id-44]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-45", {
     name: "form-id-45",
     image: "icons/formicon.png",
     html: "<p>[form-id-45]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-46", {
     name: "form-id-46",
     image: "icons/formicon.png",
     html: "<p>[form-id-46]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-47", {
     name: "form-id-47",
     image: "icons/formicon.png",
     html: "<p>[form-id-47]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-48", {
     name: "form-id-48",
     image: "icons/formicon.png",
     html: "<p>[form-id-48]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-49", {
     name: "form-id-49",
     image: "icons/formicon.png",
     html: "<p>[form-id-49]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-50", {
     name: "form-id-50",
     image: "icons/formicon.png",
     html: "<p>[form-id-50]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-51", {
     name: "form-id-51",
     image: "icons/formicon.png",
     html: "<p>[form-id-51]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-52", {
     name: "form-id-52",
     image: "icons/formicon.png",
     html: "<p>[form-id-52]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-53", {
     name: "form-id-53",
     image: "icons/formicon.png",
     html: "<p>[form-id-53]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-54", {
     name: "form-id-54",
     image: "icons/formicon.png",
     html: "<p>[form-id-54]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-55", {
     name: "form-id-55",
     image: "icons/formicon.png",
     html: "<p>[form-id-55]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-56", {
     name: "form-id-56",
     image: "icons/formicon.png",
     html: "<p>[form-id-56]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-57", {
     name: "form-id-57",
     image: "icons/formicon.png",
     html: "<p>[form-id-57]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-58", {
     name: "form-id-58",
     image: "icons/formicon.png",
     html: "<p>[form-id-58]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-59", {
     name: "form-id-59",
     image: "icons/formicon.png",
     html: "<p>[form-id-59]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-60", {
     name: "form-id-60",
     image: "icons/formicon.png",
     html: "<p>[form-id-60]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-61", {
     name: "form-id-61",
     image: "icons/formicon.png",
     html: "<p>[form-id-61]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-62", {
     name: "form-id-62",
     image: "icons/formicon.png",
     html: "<p>[form-id-62]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-63", {
     name: "form-id-63",
     image: "icons/formicon.png",
     html: "<p>[form-id-63]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-64", {
     name: "form-id-64",
     image: "icons/formicon.png",
     html: "<p>[form-id-64]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-65", {
     name: "form-id-65",
     image: "icons/formicon.png",
     html: "<p>[form-id-65]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-66", {
     name: "form-id-66",
     image: "icons/formicon.png",
     html: "<p>[form-id-66]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-67", {
     name: "form-id-67",
     image: "icons/formicon.png",
     html: "<p>[form-id-67]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-68", {
     name: "form-id-68",
     image: "icons/formicon.png",
     html: "<p>[form-id-68]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-69", {
     name: "form-id-69",
     image: "icons/formicon.png",
     html: "<p>[form-id-69]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-70", {
     name: "form-id-70",
     image: "icons/formicon.png",
     html: "<p>[form-id-70]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-71", {
     name: "form-id-71",
     image: "icons/formicon.png",
     html: "<p>[form-id-71]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-72", {
     name: "form-id-72",
     image: "icons/formicon.png",
     html: "<p>[form-id-72]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-73", {
     name: "form-id-73",
     image: "icons/formicon.png",
     html: "<p>[form-id-73]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-74", {
     name: "form-id-74",
     image: "icons/formicon.png",
     html: "<p>[form-id-74]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-75", {
     name: "form-id-75",
     image: "icons/formicon.png",
     html: "<p>[form-id-75]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-76", {
     name: "form-id-76",
     image: "icons/formicon.png",
     html: "<p>[form-id-76]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-77", {
     name: "form-id-77",
     image: "icons/formicon.png",
     html: "<p>[form-id-77]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-78", {
     name: "form-id-78",
     image: "icons/formicon.png",
     html: "<p>[form-id-78]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-79", {
     name: "form-id-79",
     image: "icons/formicon.png",
     html: "<p>[form-id-79]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-80", {
     name: "form-id-80",
     image: "icons/formicon.png",
     html: "<p>[form-id-80]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-81", {
     name: "form-id-81",
     image: "icons/formicon.png",
     html: "<p>[form-id-81]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-82", {
     name: "form-id-82",
     image: "icons/formicon.png",
     html: "<p>[form-id-82]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-83", {
     name: "form-id-83",
     image: "icons/formicon.png",
     html: "<p>[form-id-83]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-84", {
     name: "form-id-84",
     image: "icons/formicon.png",
     html: "<p>[form-id-84]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-85", {
     name: "form-id-85",
     image: "icons/formicon.png",
     html: "<p>[form-id-85]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-86", {
     name: "form-id-86",
     image: "icons/formicon.png",
     html: "<p>[form-id-86]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-87", {
     name: "form-id-87",
     image: "icons/formicon.png",
     html: "<p>[form-id-87]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-88", {
     name: "form-id-88",
     image: "icons/formicon.png",
     html: "<p>[form-id-88]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-89", {
     name: "form-id-89",
     image: "icons/formicon.png",
     html: "<p>[form-id-89]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-90", {
     name: "form-id-90",
     image: "icons/formicon.png",
     html: "<p>[form-id-90]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-91", {
     name: "form-id-91",
     image: "icons/formicon.png",
     html: "<p>[form-id-91]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-92", {
     name: "form-id-92",
     image: "icons/formicon.png",
     html: "<p>[form-id-92]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-93", {
     name: "form-id-93",
     image: "icons/formicon.png",
     html: "<p>[form-id-93]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-94", {
     name: "form-id-94",
     image: "icons/formicon.png",
     html: "<p>[form-id-94]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-95", {
     name: "form-id-95",
     image: "icons/formicon.png",
     html: "<p>[form-id-95]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-96", {
     name: "form-id-96",
     image: "icons/formicon.png",
     html: "<p>[form-id-96]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-97", {
     name: "form-id-97",
     image: "icons/formicon.png",
     html: "<p>[form-id-97]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-98", {
     name: "form-id-98",
     image: "icons/formicon.png",
     html: "<p>[form-id-98]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-99", {
     name: "form-id-99",
     image: "icons/formicon.png",
     html: "<p>[form-id-99]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-100", {
     name: "form-id-100",
     image: "icons/formicon.png",
     html: "<p>[form-id-100]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-101", {
     name: "form-id-101",
     image: "icons/formicon.png",
     html: "<p>[form-id-101]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-102", {
     name: "form-id-102",
     image: "icons/formicon.png",
     html: "<p>[form-id-102]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-103", {
     name: "form-id-103",
     image: "icons/formicon.png",
     html: "<p>[form-id-103]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-104", {
     name: "form-id-104",
     image: "icons/formicon.png",
     html: "<p>[form-id-104]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-105", {
     name: "form-id-105",
     image: "icons/formicon.png",
     html: "<p>[form-id-105]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-106", {
     name: "form-id-106",
     image: "icons/formicon.png",
     html: "<p>[form-id-106]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-107", {
     name: "form-id-107",
     image: "icons/formicon.png",
     html: "<p>[form-id-107]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-108", {
     name: "form-id-108",
     image: "icons/formicon.png",
     html: "<p>[form-id-108]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-109", {
     name: "form-id-109",
     image: "icons/formicon.png",
     html: "<p>[form-id-109]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-110", {
     name: "form-id-110",
     image: "icons/formicon.png",
     html: "<p>[form-id-110]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-111", {
     name: "form-id-111",
     image: "icons/formicon.png",
     html: "<p>[form-id-111]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-112", {
     name: "form-id-112",
     image: "icons/formicon.png",
     html: "<p>[form-id-112]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-113", {
     name: "form-id-113",
     image: "icons/formicon.png",
     html: "<p>[form-id-113]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-114", {
     name: "form-id-114",
     image: "icons/formicon.png",
     html: "<p>[form-id-114]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-115", {
     name: "form-id-115",
     image: "icons/formicon.png",
     html: "<p>[form-id-115]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-116", {
     name: "form-id-116",
     image: "icons/formicon.png",
     html: "<p>[form-id-116]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-117", {
     name: "form-id-117",
     image: "icons/formicon.png",
     html: "<p>[form-id-117]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-118", {
     name: "form-id-118",
     image: "icons/formicon.png",
     html: "<p>[form-id-118]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-119", {
     name: "form-id-119",
     image: "icons/formicon.png",
     html: "<p>[form-id-119]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-120", {
     name: "form-id-120",
     image: "icons/formicon.png",
     html: "<p>[form-id-120]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-121", {
     name: "form-id-121",
     image: "icons/formicon.png",
     html: "<p>[form-id-121]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-122", {
     name: "form-id-122",
     image: "icons/formicon.png",
     html: "<p>[form-id-122]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-123", {
     name: "form-id-123",
     image: "icons/formicon.png",
     html: "<p>[form-id-123]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-124", {
     name: "form-id-124",
     image: "icons/formicon.png",
     html: "<p>[form-id-124]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-125", {
     name: "form-id-125",
     image: "icons/formicon.png",
     html: "<p>[form-id-125]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-126", {
     name: "form-id-126",
     image: "icons/formicon.png",
     html: "<p>[form-id-126]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-127", {
     name: "form-id-127",
     image: "icons/formicon.png",
     html: "<p>[form-id-127]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-128", {
     name: "form-id-128",
     image: "icons/formicon.png",
     html: "<p>[form-id-128]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-129", {
     name: "form-id-129",
     image: "icons/formicon.png",
     html: "<p>[form-id-129]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-130", {
     name: "form-id-130",
     image: "icons/formicon.png",
     html: "<p>[form-id-130]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-131", {
     name: "form-id-131",
     image: "icons/formicon.png",
     html: "<p>[form-id-131]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-132", {
     name: "form-id-132",
     image: "icons/formicon.png",
     html: "<p>[form-id-132]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-133", {
     name: "form-id-133",
     image: "icons/formicon.png",
     html: "<p>[form-id-133]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-134", {
     name: "form-id-134",
     image: "icons/formicon.png",
     html: "<p>[form-id-134]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-135", {
     name: "form-id-135",
     image: "icons/formicon.png",
     html: "<p>[form-id-135]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-136", {
     name: "form-id-136",
     image: "icons/formicon.png",
     html: "<p>[form-id-136]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-137", {
     name: "form-id-137",
     image: "icons/formicon.png",
     html: "<p>[form-id-137]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-138", {
     name: "form-id-138",
     image: "icons/formicon.png",
     html: "<p>[form-id-138]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-139", {
     name: "form-id-139",
     image: "icons/formicon.png",
     html: "<p>[form-id-139]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-140", {
     name: "form-id-140",
     image: "icons/formicon.png",
     html: "<p>[form-id-140]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-141", {
     name: "form-id-141",
     image: "icons/formicon.png",
     html: "<p>[form-id-141]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-142", {
     name: "form-id-142",
     image: "icons/formicon.png",
     html: "<p>[form-id-142]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-143", {
     name: "form-id-143",
     image: "icons/formicon.png",
     html: "<p>[form-id-143]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-144", {
     name: "form-id-144",
     image: "icons/formicon.png",
     html: "<p>[form-id-144]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-145", {
     name: "form-id-145",
     image: "icons/formicon.png",
     html: "<p>[form-id-145]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-146", {
     name: "form-id-146",
     image: "icons/formicon.png",
     html: "<p>[form-id-146]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-147", {
     name: "form-id-147",
     image: "icons/formicon.png",
     html: "<p>[form-id-147]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-148", {
     name: "form-id-148",
     image: "icons/formicon.png",
     html: "<p>[form-id-148]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-149", {
     name: "form-id-149",
     image: "icons/formicon.png",
     html: "<p>[form-id-149]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-150", {
     name: "form-id-150",
     image: "icons/formicon.png",
     html: "<p>[form-id-150]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-151", {
     name: "form-id-151",
     image: "icons/formicon.png",
     html: "<p>[form-id-151]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-152", {
     name: "form-id-152",
     image: "icons/formicon.png",
     html: "<p>[form-id-152]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-153", {
     name: "form-id-153",
     image: "icons/formicon.png",
     html: "<p>[form-id-153]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-154", {
     name: "form-id-154",
     image: "icons/formicon.png",
     html: "<p>[form-id-154]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-155", {
     name: "form-id-155",
     image: "icons/formicon.png",
     html: "<p>[form-id-155]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-156", {
     name: "form-id-156",
     image: "icons/formicon.png",
     html: "<p>[form-id-156]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-157", {
     name: "form-id-157",
     image: "icons/formicon.png",
     html: "<p>[form-id-157]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-158", {
     name: "form-id-158",
     image: "icons/formicon.png",
     html: "<p>[form-id-158]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-159", {
     name: "form-id-159",
     image: "icons/formicon.png",
     html: "<p>[form-id-159]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-160", {
     name: "form-id-160",
     image: "icons/formicon.png",
     html: "<p>[form-id-160]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-161", {
     name: "form-id-161",
     image: "icons/formicon.png",
     html: "<p>[form-id-161]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-162", {
     name: "form-id-162",
     image: "icons/formicon.png",
     html: "<p>[form-id-162]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-163", {
     name: "form-id-163",
     image: "icons/formicon.png",
     html: "<p>[form-id-163]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-164", {
     name: "form-id-164",
     image: "icons/formicon.png",
     html: "<p>[form-id-164]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-165", {
     name: "form-id-165",
     image: "icons/formicon.png",
     html: "<p>[form-id-165]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-166", {
     name: "form-id-166",
     image: "icons/formicon.png",
     html: "<p>[form-id-166]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-167", {
     name: "form-id-167",
     image: "icons/formicon.png",
     html: "<p>[form-id-167]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-168", {
     name: "form-id-168",
     image: "icons/formicon.png",
     html: "<p>[form-id-168]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-169", {
     name: "form-id-169",
     image: "icons/formicon.png",
     html: "<p>[form-id-169]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-170", {
     name: "form-id-170",
     image: "icons/formicon.png",
     html: "<p>[form-id-170]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-171", {
     name: "form-id-171",
     image: "icons/formicon.png",
     html: "<p>[form-id-171]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-172", {
     name: "form-id-172",
     image: "icons/formicon.png",
     html: "<p>[form-id-172]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-173", {
     name: "form-id-173",
     image: "icons/formicon.png",
     html: "<p>[form-id-173]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-174", {
     name: "form-id-174",
     image: "icons/formicon.png",
     html: "<p>[form-id-174]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-175", {
     name: "form-id-175",
     image: "icons/formicon.png",
     html: "<p>[form-id-175]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-176", {
     name: "form-id-176",
     image: "icons/formicon.png",
     html: "<p>[form-id-176]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-177", {
     name: "form-id-177",
     image: "icons/formicon.png",
     html: "<p>[form-id-177]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-178", {
     name: "form-id-178",
     image: "icons/formicon.png",
     html: "<p>[form-id-178]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-179", {
     name: "form-id-179",
     image: "icons/formicon.png",
     html: "<p>[form-id-179]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-180", {
     name: "form-id-180",
     image: "icons/formicon.png",
     html: "<p>[form-id-180]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-181", {
     name: "form-id-181",
     image: "icons/formicon.png",
     html: "<p>[form-id-181]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-182", {
     name: "form-id-182",
     image: "icons/formicon.png",
     html: "<p>[form-id-182]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-183", {
     name: "form-id-183",
     image: "icons/formicon.png",
     html: "<p>[form-id-183]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-184", {
     name: "form-id-184",
     image: "icons/formicon.png",
     html: "<p>[form-id-184]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-185", {
     name: "form-id-185",
     image: "icons/formicon.png",
     html: "<p>[form-id-185]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-186", {
     name: "form-id-186",
     image: "icons/formicon.png",
     html: "<p>[form-id-186]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-187", {
     name: "form-id-187",
     image: "icons/formicon.png",
     html: "<p>[form-id-187]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-188", {
     name: "form-id-188",
     image: "icons/formicon.png",
     html: "<p>[form-id-188]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-189", {
     name: "form-id-189",
     image: "icons/formicon.png",
     html: "<p>[form-id-189]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-190", {
     name: "form-id-190",
     image: "icons/formicon.png",
     html: "<p>[form-id-190]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-191", {
     name: "form-id-191",
     image: "icons/formicon.png",
     html: "<p>[form-id-191]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-192", {
     name: "form-id-192",
     image: "icons/formicon.png",
     html: "<p>[form-id-192]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-193", {
     name: "form-id-193",
     image: "icons/formicon.png",
     html: "<p>[form-id-193]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-194", {
     name: "form-id-194",
     image: "icons/formicon.png",
     html: "<p>[form-id-194]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-195", {
     name: "form-id-195",
     image: "icons/formicon.png",
     html: "<p>[form-id-195]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-196", {
     name: "form-id-196",
     image: "icons/formicon.png",
     html: "<p>[form-id-196]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-197", {
     name: "form-id-197",
     image: "icons/formicon.png",
     html: "<p>[form-id-197]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-198", {
     name: "form-id-198",
     image: "icons/formicon.png",
     html: "<p>[form-id-198]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-199", {
     name: "form-id-199",
     image: "icons/formicon.png",
     html: "<p>[form-id-199]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-200", {
     name: "form-id-200",
     image: "icons/formicon.png",
     html: "<p>[form-id-200]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-201", {
     name: "form-id-201",
     image: "icons/formicon.png",
     html: "<p>[form-id-201]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-202", {
     name: "form-id-202",
     image: "icons/formicon.png",
     html: "<p>[form-id-202]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-203", {
     name: "form-id-203",
     image: "icons/formicon.png",
     html: "<p>[form-id-203]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-204", {
     name: "form-id-204",
     image: "icons/formicon.png",
     html: "<p>[form-id-204]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-205", {
     name: "form-id-205",
     image: "icons/formicon.png",
     html: "<p>[form-id-205]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-206", {
     name: "form-id-206",
     image: "icons/formicon.png",
     html: "<p>[form-id-206]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-207", {
     name: "form-id-207",
     image: "icons/formicon.png",
     html: "<p>[form-id-207]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-208", {
     name: "form-id-208",
     image: "icons/formicon.png",
     html: "<p>[form-id-208]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-209", {
     name: "form-id-209",
     image: "icons/formicon.png",
     html: "<p>[form-id-209]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-210", {
     name: "form-id-210",
     image: "icons/formicon.png",
     html: "<p>[form-id-210]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-211", {
     name: "form-id-211",
     image: "icons/formicon.png",
     html: "<p>[form-id-211]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-212", {
     name: "form-id-212",
     image: "icons/formicon.png",
     html: "<p>[form-id-212]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-213", {
     name: "form-id-213",
     image: "icons/formicon.png",
     html: "<p>[form-id-213]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-214", {
     name: "form-id-214",
     image: "icons/formicon.png",
     html: "<p>[form-id-214]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-215", {
     name: "form-id-215",
     image: "icons/formicon.png",
     html: "<p>[form-id-215]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-216", {
     name: "form-id-216",
     image: "icons/formicon.png",
     html: "<p>[form-id-216]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-217", {
     name: "form-id-217",
     image: "icons/formicon.png",
     html: "<p>[form-id-217]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-218", {
     name: "form-id-218",
     image: "icons/formicon.png",
     html: "<p>[form-id-218]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-219", {
     name: "form-id-219",
     image: "icons/formicon.png",
     html: "<p>[form-id-219]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-220", {
     name: "form-id-220",
     image: "icons/formicon.png",
     html: "<p>[form-id-220]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-221", {
     name: "form-id-221",
     image: "icons/formicon.png",
     html: "<p>[form-id-221]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-222", {
     name: "form-id-222",
     image: "icons/formicon.png",
     html: "<p>[form-id-222]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-223", {
     name: "form-id-223",
     image: "icons/formicon.png",
     html: "<p>[form-id-223]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-224", {
     name: "form-id-224",
     image: "icons/formicon.png",
     html: "<p>[form-id-224]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-225", {
     name: "form-id-225",
     image: "icons/formicon.png",
     html: "<p>[form-id-225]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-226", {
     name: "form-id-226",
     image: "icons/formicon.png",
     html: "<p>[form-id-226]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-227", {
     name: "form-id-227",
     image: "icons/formicon.png",
     html: "<p>[form-id-227]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-228", {
     name: "form-id-228",
     image: "icons/formicon.png",
     html: "<p>[form-id-228]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-229", {
     name: "form-id-229",
     image: "icons/formicon.png",
     html: "<p>[form-id-229]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-230", {
     name: "form-id-230",
     image: "icons/formicon.png",
     html: "<p>[form-id-230]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-231", {
     name: "form-id-231",
     image: "icons/formicon.png",
     html: "<p>[form-id-231]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-232", {
     name: "form-id-232",
     image: "icons/formicon.png",
     html: "<p>[form-id-232]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-233", {
     name: "form-id-233",
     image: "icons/formicon.png",
     html: "<p>[form-id-233]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-234", {
     name: "form-id-234",
     image: "icons/formicon.png",
     html: "<p>[form-id-234]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-235", {
     name: "form-id-235",
     image: "icons/formicon.png",
     html: "<p>[form-id-235]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-236", {
     name: "form-id-236",
     image: "icons/formicon.png",
     html: "<p>[form-id-236]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-237", {
     name: "form-id-237",
     image: "icons/formicon.png",
     html: "<p>[form-id-237]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-238", {
     name: "form-id-238",
     image: "icons/formicon.png",
     html: "<p>[form-id-238]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-239", {
     name: "form-id-239",
     image: "icons/formicon.png",
     html: "<p>[form-id-239]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-240", {
     name: "form-id-240",
     image: "icons/formicon.png",
     html: "<p>[form-id-240]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-241", {
     name: "form-id-241",
     image: "icons/formicon.png",
     html: "<p>[form-id-241]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-242", {
     name: "form-id-242",
     image: "icons/formicon.png",
     html: "<p>[form-id-242]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-243", {
     name: "form-id-243",
     image: "icons/formicon.png",
     html: "<p>[form-id-243]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-244", {
     name: "form-id-244",
     image: "icons/formicon.png",
     html: "<p>[form-id-244]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-245", {
     name: "form-id-245",
     image: "icons/formicon.png",
     html: "<p>[form-id-245]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-246", {
     name: "form-id-246",
     image: "icons/formicon.png",
     html: "<p>[form-id-246]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-247", {
     name: "form-id-247",
     image: "icons/formicon.png",
     html: "<p>[form-id-247]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-248", {
     name: "form-id-248",
     image: "icons/formicon.png",
     html: "<p>[form-id-248]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-249", {
     name: "form-id-249",
     image: "icons/formicon.png",
     html: "<p>[form-id-249]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-250", {
     name: "form-id-250",
     image: "icons/formicon.png",
     html: "<p>[form-id-250]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-251", {
     name: "form-id-251",
     image: "icons/formicon.png",
     html: "<p>[form-id-251]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-252", {
     name: "form-id-252",
     image: "icons/formicon.png",
     html: "<p>[form-id-252]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-253", {
     name: "form-id-253",
     image: "icons/formicon.png",
     html: "<p>[form-id-253]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-254", {
     name: "form-id-254",
     image: "icons/formicon.png",
     html: "<p>[form-id-254]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-255", {
     name: "form-id-255",
     image: "icons/formicon.png",
     html: "<p>[form-id-255]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-256", {
     name: "form-id-256",
     image: "icons/formicon.png",
     html: "<p>[form-id-256]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-257", {
     name: "form-id-257",
     image: "icons/formicon.png",
     html: "<p>[form-id-257]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-258", {
     name: "form-id-258",
     image: "icons/formicon.png",
     html: "<p>[form-id-258]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-259", {
     name: "form-id-259",
     image: "icons/formicon.png",
     html: "<p>[form-id-259]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-260", {
     name: "form-id-260",
     image: "icons/formicon.png",
     html: "<p>[form-id-260]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-261", {
     name: "form-id-261",
     image: "icons/formicon.png",
     html: "<p>[form-id-261]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-262", {
     name: "form-id-262",
     image: "icons/formicon.png",
     html: "<p>[form-id-262]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-263", {
     name: "form-id-263",
     image: "icons/formicon.png",
     html: "<p>[form-id-263]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-264", {
     name: "form-id-264",
     image: "icons/formicon.png",
     html: "<p>[form-id-264]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-265", {
     name: "form-id-265",
     image: "icons/formicon.png",
     html: "<p>[form-id-265]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-266", {
     name: "form-id-266",
     image: "icons/formicon.png",
     html: "<p>[form-id-266]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-267", {
     name: "form-id-267",
     image: "icons/formicon.png",
     html: "<p>[form-id-267]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-268", {
     name: "form-id-268",
     image: "icons/formicon.png",
     html: "<p>[form-id-268]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-269", {
     name: "form-id-269",
     image: "icons/formicon.png",
     html: "<p>[form-id-269]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-270", {
     name: "form-id-270",
     image: "icons/formicon.png",
     html: "<p>[form-id-270]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-271", {
     name: "form-id-271",
     image: "icons/formicon.png",
     html: "<p>[form-id-271]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-272", {
     name: "form-id-272",
     image: "icons/formicon.png",
     html: "<p>[form-id-272]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-273", {
     name: "form-id-273",
     image: "icons/formicon.png",
     html: "<p>[form-id-273]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-274", {
     name: "form-id-274",
     image: "icons/formicon.png",
     html: "<p>[form-id-274]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-275", {
     name: "form-id-275",
     image: "icons/formicon.png",
     html: "<p>[form-id-275]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-276", {
     name: "form-id-276",
     image: "icons/formicon.png",
     html: "<p>[form-id-276]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-277", {
     name: "form-id-277",
     image: "icons/formicon.png",
     html: "<p>[form-id-277]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-278", {
     name: "form-id-278",
     image: "icons/formicon.png",
     html: "<p>[form-id-278]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-279", {
     name: "form-id-279",
     image: "icons/formicon.png",
     html: "<p>[form-id-279]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-280", {
     name: "form-id-280",
     image: "icons/formicon.png",
     html: "<p>[form-id-280]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-281", {
     name: "form-id-281",
     image: "icons/formicon.png",
     html: "<p>[form-id-281]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-282", {
     name: "form-id-282",
     image: "icons/formicon.png",
     html: "<p>[form-id-282]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-283", {
     name: "form-id-283",
     image: "icons/formicon.png",
     html: "<p>[form-id-283]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-284", {
     name: "form-id-284",
     image: "icons/formicon.png",
     html: "<p>[form-id-284]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-285", {
     name: "form-id-285",
     image: "icons/formicon.png",
     html: "<p>[form-id-285]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-286", {
     name: "form-id-286",
     image: "icons/formicon.png",
     html: "<p>[form-id-286]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-287", {
     name: "form-id-287",
     image: "icons/formicon.png",
     html: "<p>[form-id-287]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-288", {
     name: "form-id-288",
     image: "icons/formicon.png",
     html: "<p>[form-id-288]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-289", {
     name: "form-id-289",
     image: "icons/formicon.png",
     html: "<p>[form-id-289]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-290", {
     name: "form-id-290",
     image: "icons/formicon.png",
     html: "<p>[form-id-290]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-291", {
     name: "form-id-291",
     image: "icons/formicon.png",
     html: "<p>[form-id-291]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-292", {
     name: "form-id-292",
     image: "icons/formicon.png",
     html: "<p>[form-id-292]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-293", {
     name: "form-id-293",
     image: "icons/formicon.png",
     html: "<p>[form-id-293]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-294", {
     name: "form-id-294",
     image: "icons/formicon.png",
     html: "<p>[form-id-294]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-295", {
     name: "form-id-295",
     image: "icons/formicon.png",
     html: "<p>[form-id-295]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-296", {
     name: "form-id-296",
     image: "icons/formicon.png",
     html: "<p>[form-id-296]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-297", {
     name: "form-id-297",
     image: "icons/formicon.png",
     html: "<p>[form-id-297]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-298", {
     name: "form-id-298",
     image: "icons/formicon.png",
     html: "<p>[form-id-298]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-299", {
     name: "form-id-299",
     image: "icons/formicon.png",
     html: "<p>[form-id-299]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-300", {
     name: "form-id-300",
     image: "icons/formicon.png",
     html: "<p>[form-id-300]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-301", {
     name: "form-id-301",
     image: "icons/formicon.png",
     html: "<p>[form-id-301]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-302", {
     name: "form-id-302",
     image: "icons/formicon.png",
     html: "<p>[form-id-302]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-303", {
     name: "form-id-303",
     image: "icons/formicon.png",
     html: "<p>[form-id-303]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-304", {
     name: "form-id-304",
     image: "icons/formicon.png",
     html: "<p>[form-id-304]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-305", {
     name: "form-id-305",
     image: "icons/formicon.png",
     html: "<p>[form-id-305]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-306", {
     name: "form-id-306",
     image: "icons/formicon.png",
     html: "<p>[form-id-306]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-307", {
     name: "form-id-307",
     image: "icons/formicon.png",
     html: "<p>[form-id-307]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-308", {
     name: "form-id-308",
     image: "icons/formicon.png",
     html: "<p>[form-id-308]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-309", {
     name: "form-id-309",
     image: "icons/formicon.png",
     html: "<p>[form-id-309]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-310", {
     name: "form-id-310",
     image: "icons/formicon.png",
     html: "<p>[form-id-310]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-311", {
     name: "form-id-311",
     image: "icons/formicon.png",
     html: "<p>[form-id-311]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-312", {
     name: "form-id-312",
     image: "icons/formicon.png",
     html: "<p>[form-id-312]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-313", {
     name: "form-id-313",
     image: "icons/formicon.png",
     html: "<p>[form-id-313]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-314", {
     name: "form-id-314",
     image: "icons/formicon.png",
     html: "<p>[form-id-314]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-315", {
     name: "form-id-315",
     image: "icons/formicon.png",
     html: "<p>[form-id-315]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-316", {
     name: "form-id-316",
     image: "icons/formicon.png",
     html: "<p>[form-id-316]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-317", {
     name: "form-id-317",
     image: "icons/formicon.png",
     html: "<p>[form-id-317]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-318", {
     name: "form-id-318",
     image: "icons/formicon.png",
     html: "<p>[form-id-318]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-319", {
     name: "form-id-319",
     image: "icons/formicon.png",
     html: "<p>[form-id-319]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-320", {
     name: "form-id-320",
     image: "icons/formicon.png",
     html: "<p>[form-id-320]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-321", {
     name: "form-id-321",
     image: "icons/formicon.png",
     html: "<p>[form-id-321]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-322", {
     name: "form-id-322",
     image: "icons/formicon.png",
     html: "<p>[form-id-322]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-323", {
     name: "form-id-323",
     image: "icons/formicon.png",
     html: "<p>[form-id-323]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-324", {
     name: "form-id-324",
     image: "icons/formicon.png",
     html: "<p>[form-id-324]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-325", {
     name: "form-id-325",
     image: "icons/formicon.png",
     html: "<p>[form-id-325]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-326", {
     name: "form-id-326",
     image: "icons/formicon.png",
     html: "<p>[form-id-326]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-327", {
     name: "form-id-327",
     image: "icons/formicon.png",
     html: "<p>[form-id-327]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-328", {
     name: "form-id-328",
     image: "icons/formicon.png",
     html: "<p>[form-id-328]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-329", {
     name: "form-id-329",
     image: "icons/formicon.png",
     html: "<p>[form-id-329]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-330", {
     name: "form-id-330",
     image: "icons/formicon.png",
     html: "<p>[form-id-330]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-331", {
     name: "form-id-331",
     image: "icons/formicon.png",
     html: "<p>[form-id-331]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-332", {
     name: "form-id-332",
     image: "icons/formicon.png",
     html: "<p>[form-id-332]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-333", {
     name: "form-id-333",
     image: "icons/formicon.png",
     html: "<p>[form-id-333]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-334", {
     name: "form-id-334",
     image: "icons/formicon.png",
     html: "<p>[form-id-334]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-335", {
     name: "form-id-335",
     image: "icons/formicon.png",
     html: "<p>[form-id-335]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-336", {
     name: "form-id-336",
     image: "icons/formicon.png",
     html: "<p>[form-id-336]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-337", {
     name: "form-id-337",
     image: "icons/formicon.png",
     html: "<p>[form-id-337]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-338", {
     name: "form-id-338",
     image: "icons/formicon.png",
     html: "<p>[form-id-338]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-339", {
     name: "form-id-339",
     image: "icons/formicon.png",
     html: "<p>[form-id-339]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-340", {
     name: "form-id-340",
     image: "icons/formicon.png",
     html: "<p>[form-id-340]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-341", {
     name: "form-id-341",
     image: "icons/formicon.png",
     html: "<p>[form-id-341]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-342", {
     name: "form-id-342",
     image: "icons/formicon.png",
     html: "<p>[form-id-342]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-343", {
     name: "form-id-343",
     image: "icons/formicon.png",
     html: "<p>[form-id-343]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-344", {
     name: "form-id-344",
     image: "icons/formicon.png",
     html: "<p>[form-id-344]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-345", {
     name: "form-id-345",
     image: "icons/formicon.png",
     html: "<p>[form-id-345]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-346", {
     name: "form-id-346",
     image: "icons/formicon.png",
     html: "<p>[form-id-346]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-347", {
     name: "form-id-347",
     image: "icons/formicon.png",
     html: "<p>[form-id-347]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-348", {
     name: "form-id-348",
     image: "icons/formicon.png",
     html: "<p>[form-id-348]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-349", {
     name: "form-id-349",
     image: "icons/formicon.png",
     html: "<p>[form-id-349]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-350", {
     name: "form-id-350",
     image: "icons/formicon.png",
     html: "<p>[form-id-350]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-351", {
     name: "form-id-351",
     image: "icons/formicon.png",
     html: "<p>[form-id-351]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-352", {
     name: "form-id-352",
     image: "icons/formicon.png",
     html: "<p>[form-id-352]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-353", {
     name: "form-id-353",
     image: "icons/formicon.png",
     html: "<p>[form-id-353]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-354", {
     name: "form-id-354",
     image: "icons/formicon.png",
     html: "<p>[form-id-354]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-355", {
     name: "form-id-355",
     image: "icons/formicon.png",
     html: "<p>[form-id-355]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-356", {
     name: "form-id-356",
     image: "icons/formicon.png",
     html: "<p>[form-id-356]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-357", {
     name: "form-id-357",
     image: "icons/formicon.png",
     html: "<p>[form-id-357]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-358", {
     name: "form-id-358",
     image: "icons/formicon.png",
     html: "<p>[form-id-358]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-359", {
     name: "form-id-359",
     image: "icons/formicon.png",
     html: "<p>[form-id-359]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-360", {
     name: "form-id-360",
     image: "icons/formicon.png",
     html: "<p>[form-id-360]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-361", {
     name: "form-id-361",
     image: "icons/formicon.png",
     html: "<p>[form-id-361]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-362", {
     name: "form-id-362",
     image: "icons/formicon.png",
     html: "<p>[form-id-362]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-363", {
     name: "form-id-363",
     image: "icons/formicon.png",
     html: "<p>[form-id-363]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-364", {
     name: "form-id-364",
     image: "icons/formicon.png",
     html: "<p>[form-id-364]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-365", {
     name: "form-id-365",
     image: "icons/formicon.png",
     html: "<p>[form-id-365]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-366", {
     name: "form-id-366",
     image: "icons/formicon.png",
     html: "<p>[form-id-366]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-367", {
     name: "form-id-367",
     image: "icons/formicon.png",
     html: "<p>[form-id-367]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-368", {
     name: "form-id-368",
     image: "icons/formicon.png",
     html: "<p>[form-id-368]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-369", {
     name: "form-id-369",
     image: "icons/formicon.png",
     html: "<p>[form-id-369]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-370", {
     name: "form-id-370",
     image: "icons/formicon.png",
     html: "<p>[form-id-370]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-371", {
     name: "form-id-371",
     image: "icons/formicon.png",
     html: "<p>[form-id-371]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-372", {
     name: "form-id-372",
     image: "icons/formicon.png",
     html: "<p>[form-id-372]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-373", {
     name: "form-id-373",
     image: "icons/formicon.png",
     html: "<p>[form-id-373]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-374", {
     name: "form-id-374",
     image: "icons/formicon.png",
     html: "<p>[form-id-374]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-375", {
     name: "form-id-375",
     image: "icons/formicon.png",
     html: "<p>[form-id-375]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-376", {
     name: "form-id-376",
     image: "icons/formicon.png",
     html: "<p>[form-id-376]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-377", {
     name: "form-id-377",
     image: "icons/formicon.png",
     html: "<p>[form-id-377]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-378", {
     name: "form-id-378",
     image: "icons/formicon.png",
     html: "<p>[form-id-378]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-379", {
     name: "form-id-379",
     image: "icons/formicon.png",
     html: "<p>[form-id-379]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-380", {
     name: "form-id-380",
     image: "icons/formicon.png",
     html: "<p>[form-id-380]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-381", {
     name: "form-id-381",
     image: "icons/formicon.png",
     html: "<p>[form-id-381]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-382", {
     name: "form-id-382",
     image: "icons/formicon.png",
     html: "<p>[form-id-382]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-383", {
     name: "form-id-383",
     image: "icons/formicon.png",
     html: "<p>[form-id-383]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-384", {
     name: "form-id-384",
     image: "icons/formicon.png",
     html: "<p>[form-id-384]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-385", {
     name: "form-id-385",
     image: "icons/formicon.png",
     html: "<p>[form-id-385]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-386", {
     name: "form-id-386",
     image: "icons/formicon.png",
     html: "<p>[form-id-386]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-387", {
     name: "form-id-387",
     image: "icons/formicon.png",
     html: "<p>[form-id-387]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-388", {
     name: "form-id-388",
     image: "icons/formicon.png",
     html: "<p>[form-id-388]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-389", {
     name: "form-id-389",
     image: "icons/formicon.png",
     html: "<p>[form-id-389]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-390", {
     name: "form-id-390",
     image: "icons/formicon.png",
     html: "<p>[form-id-390]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-391", {
     name: "form-id-391",
     image: "icons/formicon.png",
     html: "<p>[form-id-391]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-392", {
     name: "form-id-392",
     image: "icons/formicon.png",
     html: "<p>[form-id-392]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-393", {
     name: "form-id-393",
     image: "icons/formicon.png",
     html: "<p>[form-id-393]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-394", {
     name: "form-id-394",
     image: "icons/formicon.png",
     html: "<p>[form-id-394]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-395", {
     name: "form-id-395",
     image: "icons/formicon.png",
     html: "<p>[form-id-395]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-396", {
     name: "form-id-396",
     image: "icons/formicon.png",
     html: "<p>[form-id-396]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-397", {
     name: "form-id-397",
     image: "icons/formicon.png",
     html: "<p>[form-id-397]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-398", {
     name: "form-id-398",
     image: "icons/formicon.png",
     html: "<p>[form-id-398]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-399", {
     name: "form-id-399",
     image: "icons/formicon.png",
     html: "<p>[form-id-399]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-400", {
     name: "form-id-400",
     image: "icons/formicon.png",
     html: "<p>[form-id-400]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-401", {
     name: "form-id-401",
     image: "icons/formicon.png",
     html: "<p>[form-id-401]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-402", {
     name: "form-id-402",
     image: "icons/formicon.png",
     html: "<p>[form-id-402]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-403", {
     name: "form-id-403",
     image: "icons/formicon.png",
     html: "<p>[form-id-403]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-404", {
     name: "form-id-404",
     image: "icons/formicon.png",
     html: "<p>[form-id-404]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-405", {
     name: "form-id-405",
     image: "icons/formicon.png",
     html: "<p>[form-id-405]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-406", {
     name: "form-id-406",
     image: "icons/formicon.png",
     html: "<p>[form-id-406]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-407", {
     name: "form-id-407",
     image: "icons/formicon.png",
     html: "<p>[form-id-407]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-408", {
     name: "form-id-408",
     image: "icons/formicon.png",
     html: "<p>[form-id-408]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-409", {
     name: "form-id-409",
     image: "icons/formicon.png",
     html: "<p>[form-id-409]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-410", {
     name: "form-id-410",
     image: "icons/formicon.png",
     html: "<p>[form-id-410]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-411", {
     name: "form-id-411",
     image: "icons/formicon.png",
     html: "<p>[form-id-411]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-412", {
     name: "form-id-412",
     image: "icons/formicon.png",
     html: "<p>[form-id-412]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-413", {
     name: "form-id-413",
     image: "icons/formicon.png",
     html: "<p>[form-id-413]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-414", {
     name: "form-id-414",
     image: "icons/formicon.png",
     html: "<p>[form-id-414]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-415", {
     name: "form-id-415",
     image: "icons/formicon.png",
     html: "<p>[form-id-415]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-416", {
     name: "form-id-416",
     image: "icons/formicon.png",
     html: "<p>[form-id-416]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-417", {
     name: "form-id-417",
     image: "icons/formicon.png",
     html: "<p>[form-id-417]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-418", {
     name: "form-id-418",
     image: "icons/formicon.png",
     html: "<p>[form-id-418]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-419", {
     name: "form-id-419",
     image: "icons/formicon.png",
     html: "<p>[form-id-419]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-420", {
     name: "form-id-420",
     image: "icons/formicon.png",
     html: "<p>[form-id-420]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-421", {
     name: "form-id-421",
     image: "icons/formicon.png",
     html: "<p>[form-id-421]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-422", {
     name: "form-id-422",
     image: "icons/formicon.png",
     html: "<p>[form-id-422]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-423", {
     name: "form-id-423",
     image: "icons/formicon.png",
     html: "<p>[form-id-423]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-424", {
     name: "form-id-424",
     image: "icons/formicon.png",
     html: "<p>[form-id-424]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-425", {
     name: "form-id-425",
     image: "icons/formicon.png",
     html: "<p>[form-id-425]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-426", {
     name: "form-id-426",
     image: "icons/formicon.png",
     html: "<p>[form-id-426]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-427", {
     name: "form-id-427",
     image: "icons/formicon.png",
     html: "<p>[form-id-427]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-428", {
     name: "form-id-428",
     image: "icons/formicon.png",
     html: "<p>[form-id-428]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-429", {
     name: "form-id-429",
     image: "icons/formicon.png",
     html: "<p>[form-id-429]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-430", {
     name: "form-id-430",
     image: "icons/formicon.png",
     html: "<p>[form-id-430]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-431", {
     name: "form-id-431",
     image: "icons/formicon.png",
     html: "<p>[form-id-431]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-432", {
     name: "form-id-432",
     image: "icons/formicon.png",
     html: "<p>[form-id-432]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-433", {
     name: "form-id-433",
     image: "icons/formicon.png",
     html: "<p>[form-id-433]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-434", {
     name: "form-id-434",
     image: "icons/formicon.png",
     html: "<p>[form-id-434]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-435", {
     name: "form-id-435",
     image: "icons/formicon.png",
     html: "<p>[form-id-435]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-436", {
     name: "form-id-436",
     image: "icons/formicon.png",
     html: "<p>[form-id-436]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-437", {
     name: "form-id-437",
     image: "icons/formicon.png",
     html: "<p>[form-id-437]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-438", {
     name: "form-id-438",
     image: "icons/formicon.png",
     html: "<p>[form-id-438]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-439", {
     name: "form-id-439",
     image: "icons/formicon.png",
     html: "<p>[form-id-439]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-440", {
     name: "form-id-440",
     image: "icons/formicon.png",
     html: "<p>[form-id-440]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-441", {
     name: "form-id-441",
     image: "icons/formicon.png",
     html: "<p>[form-id-441]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-442", {
     name: "form-id-442",
     image: "icons/formicon.png",
     html: "<p>[form-id-442]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-443", {
     name: "form-id-443",
     image: "icons/formicon.png",
     html: "<p>[form-id-443]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-444", {
     name: "form-id-444",
     image: "icons/formicon.png",
     html: "<p>[form-id-444]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-445", {
     name: "form-id-445",
     image: "icons/formicon.png",
     html: "<p>[form-id-445]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-446", {
     name: "form-id-446",
     image: "icons/formicon.png",
     html: "<p>[form-id-446]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-447", {
     name: "form-id-447",
     image: "icons/formicon.png",
     html: "<p>[form-id-447]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-448", {
     name: "form-id-448",
     image: "icons/formicon.png",
     html: "<p>[form-id-448]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-449", {
     name: "form-id-449",
     image: "icons/formicon.png",
     html: "<p>[form-id-449]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-450", {
     name: "form-id-450",
     image: "icons/formicon.png",
     html: "<p>[form-id-450]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-451", {
     name: "form-id-451",
     image: "icons/formicon.png",
     html: "<p>[form-id-451]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-452", {
     name: "form-id-452",
     image: "icons/formicon.png",
     html: "<p>[form-id-452]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-453", {
     name: "form-id-453",
     image: "icons/formicon.png",
     html: "<p>[form-id-453]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-454", {
     name: "form-id-454",
     image: "icons/formicon.png",
     html: "<p>[form-id-454]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-455", {
     name: "form-id-455",
     image: "icons/formicon.png",
     html: "<p>[form-id-455]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-456", {
     name: "form-id-456",
     image: "icons/formicon.png",
     html: "<p>[form-id-456]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-457", {
     name: "form-id-457",
     image: "icons/formicon.png",
     html: "<p>[form-id-457]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-458", {
     name: "form-id-458",
     image: "icons/formicon.png",
     html: "<p>[form-id-458]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-459", {
     name: "form-id-459",
     image: "icons/formicon.png",
     html: "<p>[form-id-459]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-460", {
     name: "form-id-460",
     image: "icons/formicon.png",
     html: "<p>[form-id-460]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-461", {
     name: "form-id-461",
     image: "icons/formicon.png",
     html: "<p>[form-id-461]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-462", {
     name: "form-id-462",
     image: "icons/formicon.png",
     html: "<p>[form-id-462]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-463", {
     name: "form-id-463",
     image: "icons/formicon.png",
     html: "<p>[form-id-463]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-464", {
     name: "form-id-464",
     image: "icons/formicon.png",
     html: "<p>[form-id-464]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-465", {
     name: "form-id-465",
     image: "icons/formicon.png",
     html: "<p>[form-id-465]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-466", {
     name: "form-id-466",
     image: "icons/formicon.png",
     html: "<p>[form-id-466]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-467", {
     name: "form-id-467",
     image: "icons/formicon.png",
     html: "<p>[form-id-467]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-468", {
     name: "form-id-468",
     image: "icons/formicon.png",
     html: "<p>[form-id-468]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-469", {
     name: "form-id-469",
     image: "icons/formicon.png",
     html: "<p>[form-id-469]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-470", {
     name: "form-id-470",
     image: "icons/formicon.png",
     html: "<p>[form-id-470]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-471", {
     name: "form-id-471",
     image: "icons/formicon.png",
     html: "<p>[form-id-471]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-472", {
     name: "form-id-472",
     image: "icons/formicon.png",
     html: "<p>[form-id-472]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-473", {
     name: "form-id-473",
     image: "icons/formicon.png",
     html: "<p>[form-id-473]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-474", {
     name: "form-id-474",
     image: "icons/formicon.png",
     html: "<p>[form-id-474]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-475", {
     name: "form-id-475",
     image: "icons/formicon.png",
     html: "<p>[form-id-475]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-476", {
     name: "form-id-476",
     image: "icons/formicon.png",
     html: "<p>[form-id-476]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-477", {
     name: "form-id-477",
     image: "icons/formicon.png",
     html: "<p>[form-id-477]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-478", {
     name: "form-id-478",
     image: "icons/formicon.png",
     html: "<p>[form-id-478]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-479", {
     name: "form-id-479",
     image: "icons/formicon.png",
     html: "<p>[form-id-479]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-480", {
     name: "form-id-480",
     image: "icons/formicon.png",
     html: "<p>[form-id-480]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-481", {
     name: "form-id-481",
     image: "icons/formicon.png",
     html: "<p>[form-id-481]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-482", {
     name: "form-id-482",
     image: "icons/formicon.png",
     html: "<p>[form-id-482]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-483", {
     name: "form-id-483",
     image: "icons/formicon.png",
     html: "<p>[form-id-483]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-484", {
     name: "form-id-484",
     image: "icons/formicon.png",
     html: "<p>[form-id-484]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-485", {
     name: "form-id-485",
     image: "icons/formicon.png",
     html: "<p>[form-id-485]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-486", {
     name: "form-id-486",
     image: "icons/formicon.png",
     html: "<p>[form-id-486]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-487", {
     name: "form-id-487",
     image: "icons/formicon.png",
     html: "<p>[form-id-487]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-488", {
     name: "form-id-488",
     image: "icons/formicon.png",
     html: "<p>[form-id-488]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-489", {
     name: "form-id-489",
     image: "icons/formicon.png",
     html: "<p>[form-id-489]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-490", {
     name: "form-id-490",
     image: "icons/formicon.png",
     html: "<p>[form-id-490]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-491", {
     name: "form-id-491",
     image: "icons/formicon.png",
     html: "<p>[form-id-491]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-492", {
     name: "form-id-492",
     image: "icons/formicon.png",
     html: "<p>[form-id-492]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-493", {
     name: "form-id-493",
     image: "icons/formicon.png",
     html: "<p>[form-id-493]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-494", {
     name: "form-id-494",
     image: "icons/formicon.png",
     html: "<p>[form-id-494]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-495", {
     name: "form-id-495",
     image: "icons/formicon.png",
     html: "<p>[form-id-495]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-496", {
     name: "form-id-496",
     image: "icons/formicon.png",
     html: "<p>[form-id-496]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-497", {
     name: "form-id-497",
     image: "icons/formicon.png",
     html: "<p>[form-id-497]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-498", {
     name: "form-id-498",
     image: "icons/formicon.png",
     html: "<p>[form-id-498]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-499", {
     name: "form-id-499",
     image: "icons/formicon.png",
     html: "<p>[form-id-499]</p>",
});

Vvveb.Components.extend("_base", "html/form-id-500", {
     name: "form-id-500",
     image: "icons/formicon.png",
     html: "<p>[form-id-500]</p>",
});