<?php
class pagination {
	public $arrIgnoreIndex;
	public $itemsPerPage;
	public $range;
	public $currentPage;
	public $total;
	public $textNav;
	public $limit;
	public $itemSelect;
	private $AjaxPagination = false;
	private $load_more_only = false;
	private $AjaxUrl		= '';
	private $_navigation;      
	private $_link;
	private $_pageNumHtml;
	private $_itemHtml;
	private $_htmlLoadMore;
	private $separator;
	/**
	 * Constructor
	 */
	public function __construct($arrConfig=array())
	{
		//set default values
		$this->itemsPerPage = 25;
		$this->range        = 5;
		$this->currentPage  = 1;       
		$this->total        = 0;
		$this->textNav      = false;
		$this->itemSelect   = array(5,25,50,100,'All');        
		//private values
		$this->_navigation  = array(
				'next'=>'Next',
				'pre' =>'Pre',
				'ipp' =>'Item per page'
		);
		$this->arrIgnoreIndex = array();
		if(isset($arrConfig['arrIgnoreIndex'])) {
			$this->arrIgnoreIndex = $arrConfig['arrIgnoreIndex'];
		}
		if(isset($arrConfig['AjaxPagination'])) {
			$this->AjaxPagination = $arrConfig['AjaxPagination'];
		}
		if(isset($arrConfig['load_more_only'])) {
			$this->load_more_only = $arrConfig['load_more_only'];
		}
		if(isset($arrConfig['AjaxUrl'])) {
			$this->AjaxUrl = $arrConfig['AjaxUrl'];
		}
		//$this->_link         = filter_var($_SERVER['PHP_SELF'], FILTER_SANITIZE_STRING);
		$this->_link		 = $_SERVER['REQUEST_URI'];
		
		
		$arrGet = array();
		foreach( $_GET as $index => $value ){
			if($index == 'current') {
				continue;
			}
			if(isset($this->arrIgnoreIndex) && is_array($this->arrIgnoreIndex) && count($this->arrIgnoreIndex) && in_array($index,$this->arrIgnoreIndex)) {
				continue;
			}
			$arrGet[] = $index . '=' . $value;
		}
		
		$arrExplode = explode("?",$_SERVER['REQUEST_URI']);
		if(isset($arrExplode[0]) && !empty( $arrExplode[0] )) {
			$this->_link = $arrExplode[0];
			if(isset($arrGet) && is_array($arrGet) && count($arrGet)) {
				$this->_link = $this->_link . "?" . implode("&", $arrGet);
			}
		}
		
		if(isset($_GET) && is_array($_GET) && count($_GET) && isset($arrGet) && is_array($arrGet) && count($arrGet)) {
			$this->separator = '&';
		} else {
			$this->separator = '?';
		}
		$this->_pageNumHtml		= '';
		$this->_itemHtml		= '';
		$this->_htmlLoadMore	= '';
		
		if(isset($arrConfig['itemsPerPage'])) {
			$this->itemsPerPage = $arrConfig['itemsPerPage'];
		}
	}
	 
	/**
	 * paginate main function
	 *
	 * @author              Swyam Joshi ( swyam.joshi@gmail.com )
	 * @access              public
	 * @return              type
	 */
	public function paginate()
	{
		//get current page
		if(isset($_GET['current'])){
			$this->currentPage  = $_GET['current'];    
		}          
		//get item per page
		if(isset($_GET['item'])){
			$this->itemsPerPage = $_GET['item'];
		}
		// set limit sql stuff
		$this->limit = ($this->currentPage-1)*$this->itemsPerPage . "," .  $this->itemsPerPage;
		
		if($this->total > $this->itemsPerPage);
		$this->total = ceil($this->total/$this->itemsPerPage);
		//get page numbers
		$this->_pageNumHtml = $this->_getPageNumbers();
		//get item per page select box
		$this->_itemHtml    = $this->_getItemSelect();
		// prepare ajax load more button
		$this->_htmlLoadMore = $this->_getLoadMoreButton();
		
	}
	public function limit() {
		$this->paginate();
		return $this->limit;
	}
	/**
	 * return pagination numbers in a format of UL list
	 *
	 * @author              Swyam Joshi ( swyam.joshi@gmail.com )
	 * @access              public
	 * @param               type $parameter
	 * @return              string
	 */
	public function pageNumbers()
	{
		if(empty($this->_pageNumHtml)){
			//exit('Please call function paginate() first.');
			$this->paginate();
		}
		if( $this->load_more_only ) {
			return $this->_htmlLoadMore;
		} else {
			return $this->_pageNumHtml;
		}
		
	}
	 
	/**
	 * return jump menu in a format of select box
	 *
	 * @author              Swyam Joshi ( swyam.joshi@gmail.com )
	 * @access              public
	 * @return              string
	 */
	public function itemsPerPage()
	{         
		if(empty($this->_itemHtml)){
			exit('Please call function paginate() first.');
		}
		return $this->_itemHtml;   
	}
	 
	/**
	 * return page numbers html formats
	 *
	 * @author              Swyam Joshi ( swyam.joshi@gmail.com )
	 * @access              public
	 * @return              string
	 */
	private function  _getPageNumbers()
	{
		$html  = '<ul class="pagination hityah-pagination">';
		//previous link button
		if($this->textNav && ($this->currentPage>1) ){
			$html.= '<li class="page-item"><a href="'.$this->_link .$this->separator.'current='.($this->currentPage-1).'"';
			$html.= ' class="page-link">'.$this->_navigation['pre'].'</a></li>';
		}          
		//do ranged pagination only when total pages is greater than the range
		if($this->total > $this->range){               
			$start = ($this->currentPage <= $this->range)?1:($this->currentPage - $this->range);
			$end   = ($this->total - $this->currentPage >= $this->range)?($this->currentPage+$this->range): $this->total;
		}else{
			$start = 1;
			$end   = $this->total;
		}   
		//loop through page numbers
		for($i = $start; $i <= $end; $i++){
				$html.= '<li';
				if($i==$this->currentPage) $html.= " class='active page-item'";
				$html.= '><a href="'.$this->_link . $this->separator . 'current='.$i.'"';
				if($i==$this->currentPage) $html.= "class='current page-link'";
				$html.= ' class="page-item">'.$i.'</a></li>';
		}          
		//next link button
		if($this->textNav&&($this->currentPage<$this->total)){
			$html.= '<li class="page-item"><a href="'.$this->_link . $this->separator . 'current='.($this->currentPage+1).'"';
			$html.= ' class="page-link">'.$this->_navigation['next'].'</a></li>';
		}
		$html .= '</ul>';
		return $html;
	}
	
	/**
	 * return page numbers html formats
	 *
	 * @author              Swyam Joshi ( swyam.joshi@gmail.com )
	 * @access              public
	 * @return              string
	 */
	private function  _getLoadMoreButton() {
		
		//<button class="btn load_more">Load More</button>
	
		$html="";
		//do ranged pagination only when total pages is greater than the range
		if($this->total > $this->range){               
			$start = ($this->currentPage <= $this->range)?1:($this->currentPage - $this->range);
			$end   = ($this->total - $this->currentPage >= $this->range)?($this->currentPage+$this->range): $this->total;
		}else{
			$start = 1;
			$end   = $this->total;
		}
		//next link button
		if( $this->currentPage < $this->total ) {
			/*
			$html.= '<li><a href="'.$this->_link . $this->separator . 'current='.($this->currentPage+1).'"';
			$html.= '>'.$this->_navigation['next'].'</a></li>';
			*/
			$html = '<div class="c-hityah-load-more">';
			if( $this->AjaxPagination && !empty( $this->AjaxUrl )) {
				$html.='
				<button class="load_more qp-ajax-load-more-loading hide ">Loading more brands &amp; bonuses...</button>
				<button class="load_more qp-ajax-load-more" data.href="' . $this->AjaxUrl .'" data.end="'.$this->total.'" data.current="'.$this->currentPage.'">Load More...</button>';
			} else {
				$html.='<a href="'.$this->_link . $this->separator . 'current='.($this->currentPage+1).'"><button class="load_more">Load More...</button></a>';
			}
			$html.= '</div>';
		}
		return $html;
	}
	 
	/**
	 * return item select box
	 *
	 * @author              Swyam Joshi ( swyam.joshi@gmail.com )
	 * @access              public
	 * @return              string
	 */
	private function  _getItemSelect()
	{
		$items = '';
		$ippArray = $this->itemSelect;             
		foreach($ippArray as $ippOpt){  
			$items .= ($ippOpt == $this->itemsPerPage) ? "<option selected value=\"$ippOpt\">$ippOpt</option>\n":"<option value=\"$ippOpt\">$ippOpt</option>\n";
		}              
		return "<span class=\"paginate\">".$this->_navigation['ipp']."</span>
		<select class=\"paginate\" onchange=\"window.location='".$this->_link."".$this->separator."current=1&item='+this[this.selectedIndex].value;return false\">$items</select>\n";     
	}
}

?>